       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRCFPER.
      *
      *    Routine per esportazione righi personalizzati XML
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritabsl'.
           COPY 'grifatsl'.
           COPY 'gribctsl'.
           COPY 'gribcrsl'.
           COPY 'griclfsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritab'.
           COPY 'grifat'.
           COPY 'gribct'.
           COPY 'gribcr'.
           COPY 'griclf'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.    
           COPY 'gritabrk'.
           COPY 'griclfrk'.
           COPY 'parzf'.
           COPY 'parag'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-FAT.
           05 FILLER PIC X(6) VALUE 'fattur'.
           05 FATTIV PIC X    VALUE SPACE.
           05 FILLER PIC X(8) VALUE SPACE.
       01  ID-BCT PIC X(15) VALUE 'bolcte'.
       01  ID-BCR PIC X(15) VALUE 'bolcri'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-FAT   PIC XX.
           05 SF-BCT   PIC XX.
           05 SF-BCR   PIC XX.
           05 SF-CLF   PIC XX.
       01  AREE.
           05 COMNOTE PIC X(500) VALUE SPACE.
           05 COM-DESC PIC X(500).
           05 K   PIC 9(5) VALUE ZERO.
           05 K1  PIC 9(5) VALUE ZERO.
           05 KU1 PIC 9(5) VALUE ZERO.
           05 KU2 PIC 9(5) VALUE ZERO.
           05 FLGTES PIC 9 VALUE ZERO.
           05 COMNUM   PIC 9(10)V9(6).
           05 CODCLI.
              10 CMAS   PIC 9(2).
              10 CCOD   PIC 9(5).
       01  PAR-P-MDT.
           05 P-MDT-AZI   PIC 999.
           05 P-MDT-TDOC  PIC 9.
           05 P-MDT-KEY   PIC X(15).
           05 P-MDT-FLGS  PIC 9.
           05 P-MDT-DATA  PIC 9(5).
           05 P-MDT-NCOL  PIC 99.
           05 P-MDT-TESTO PIC X(76).
           05 P-MDT-FLGE  PIC 9.
       LINKAGE SECTION.
           COPY 'parfper'.
           COPY 'parwxml-2-72'.
       PROCEDURE DIVISION USING PARFPER PARWXML.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcltab'.
           COPY 'dclfat'.
           COPY 'dclbct'.
           COPY 'dclbcr'.
           COPY 'dclclf'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
      *
           IF PFPER-TIPO = ZERO
              PERFORM OPEN-FILE THRU EX-OPEN-FILE.
           IF PFPER-TIPO = 1
              PERFORM INIZIO-FATTURA THRU EX-INIZIO-FATTURA.
           IF PFPER-TIPO = 2
              PERFORM INIZIO-BOLLA THRU EX-INIZIO-BOLLA.
           IF PFPER-TIPO = 3
              PERFORM INIZIO-RIGO THRU EX-INIZIO-RIGO.
           IF PFPER-TIPO = 4
              PERFORM FINE-RIGO THRU EX-FINE-RIGO.
           IF PFPER-TIPO = 5
              PERFORM FINE-BOLLA THRU EX-FINE-BOLLA.
           IF PFPER-TIPO = 6
              PERFORM FINE-FATTURA THRU EX-FINE-FATTURA.
           IF PFPER-TIPO = 99
              PERFORM CLOSE-FILE THRU EX-CLOSE-FILE.
      *
           MOVE SPACE TO PWXM-CAMPO.
           GO TO FINE.
      *
       ERRIO.
      *    COPY 'errcal'.
       FINE.
      *    CLOSE ANAAZI TABELL.
       ESCI.
           EXIT PROGRAM.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *-------------------------------
       OPEN-FILE.
           OPEN INPUT ANAAZI TABELL BOLCTE BOLCRI.
           OPEN INPUT ANACLF.
           MOVE PFPER-CATT TO FATTIV.
           IF FATTIV = '0' MOVE SPACE TO FATTIV.
           OPEN INPUT FATTUR.
      *
       EX-OPEN-FILE.
           EXIT.
      *-------------------------------
       INIZIO-FATTURA.
      * ATTENZIONE INCREMENTARE IL PFPER-CONT AD OGNI RIGO  
          MOVE PFPER-KEYFT TO KEYFT.
          READ FATTUR INVALID GO TO EX-INIZIO-FATTURA.
      *
          MOVE 1 TO KTB-COD KTB-TIP.
          READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
          IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
          MOVE T01-MCLI TO CMAS.
      *
          MOVE FAT-CDCLI TO CCOD.
          MOVE PFPER-AZI TO KCF-AZI.
          MOVE CODCLI    TO KCF-COD.
          READ ANACLF INTO REKCLF INVALID KEY
               GO TO EX-INIZIO-FATTURA.
       EX-INIZIO-FATTURA.
           EXIT.
      *-------------------------------
       INIZIO-BOLLA.
      * ATTENZIONE INCREMENTARE IL PFPER-CONT AD OGNI RIGO  
          MOVE PFPER-KEYCR TO KEYBC.
          READ BOLCTE INVALID GO TO EX-INIZIO-BOLLA.
      *
       EX-INIZIO-BOLLA.
           EXIT.
      *-------------------------------
       INIZIO-RIGO.
      * ATTENZIONE INCREMENTARE IL PFPER-CONT AD OGNI RIGO  
          MOVE PFPER-KEYCR TO KEYCR.
          READ BOLCRI INVALID GO TO EX-INIZIO-RIGO.
      *
       EX-INIZIO-RIGO.
           EXIT.
      *-------------------------------
       FINE-RIGO.
      * ATTENZIONE INCREMENTARE IL PFPER-CONT AD OGNI RIGO  
      *
       EX-FINE-RIGO.
           EXIT.
      *-------------------------------
       FINE-BOLLA.
      * ATTENZIONE INCREMENTARE IL PFPER-CONT AD OGNI RIGO  
      *
       EX-FINE-BOLLA.
           EXIT.
      *-------------------------------
       FINE-FATTURA.
      * ATTENZIONE INCREMENTARE IL PFPER-CONT AD OGNI RIGO  
      *
       EX-FINE-FATTURA.
           EXIT.
      *-------------------------------
       CLOSE-FILE.
           CLOSE ANAAZI TABELL BOLCTE BOLCRI FATTUR ANACLF.
       EX-CLOSE-FILE.
           EXIT.
      *-------------------------------
       CERCA-ULTIMO.
           MOVE 500 TO KU1 KU2.
           IF COM-DESC = SPACE
              MOVE 1 TO KU1 KU2
              GO TO EX-CERCA-ULTIMO.
           PERFORM UNTIL COM-DESC(KU1:1) NOT = SPACE
               SUBTRACT 1 FROM KU1.
           MOVE KU1 TO KU2.
      *
       EX-CERCA-ULTIMO.
           EXIT.
      *-------------------------------
       T-CIFRA.
           MOVE 1 TO K1.
           PERFORM UNTIL COMNUM(K1:1) NOT = ZERO
             ADD 1 TO K1. 
           IF K1 > 10
              MOVE 10 TO K1. 
       EX-T-CIFRA.
           EXIT.
      *------------------
