       IDENTIFICATION DIVISION.
       PROGRAM-ID. VFAT500.
      *
      * OGGETTO: Esportazione Fatture PA 
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gribctsl'.
           COPY 'griactsl'.
           COPY 'griaftsl'.
           COPY 'gribcrsl'.
           COPY 'griazisl'.
           COPY 'griaazsl'.
           COPY 'grifatsl'.
           COPY 'griclfsl'.
           COPY 'gritabsl'.
           COPY 'gritfesl'.
           COPY 'griordsl'.
           COPY 'grincrsl'.
           COPY 'griacfsl'.
      **** rel 7.1
           COPY 'gribansl'.
           COPY 'griabasl'.
      ************
      **** rel 7.2
           COPY 'grialgsl'.
           COPY 'grispssl'.
           COPY 'grisstsl'.
           COPY 'grib2asl'.
           COPY 'gribktsl'.
           COPY 'grib2psl'.
           COPY 'grispisl'.
           COPY 'griwsisl'.
           COPY 'griaimsl'.
           COPY 'gripbrsl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV
                  ALTERNATE RECORD KEY SKEYLV1 = KLV-AZI KLV-NBOL
                                                 KLV-NUBOL KLV-PRGN
                                                 WITH DUPLICATES
                  STATUS SF-LAV.
      ************
           COPY 'grintasl'.
           COPY 'grimtisl'.
           COPY 'grimrisl'.
           COPY 'grib2ssl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'gribct'.
           COPY 'griact'.
           COPY 'griaft'.
           COPY 'gribcr'.
           COPY 'griazi'.
           COPY 'griaaz'.
           COPY 'grifat'.
           COPY 'griclf'.
           COPY 'gritab'.
           COPY 'gritfe'.
           COPY 'griord'.
           COPY 'grincr'.
           COPY 'griacf'.
      **** rel 7.1
           COPY 'griban'.
           COPY 'griaba'.
      ************
      **** rel 7.2
           COPY 'grialg'.
           COPY 'grisps'.
           COPY 'grisst'.
           COPY 'grib2a'.
           COPY 'gribkt'.
           COPY 'grib2p'.
           COPY 'grispi'.
           COPY 'griwsi'.
           COPY 'griaim'.
           COPY 'gripbr'.
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 19 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLV.
             05 KLV-AZI   PIC 9(3).
             05 KLV-NUM   PIC 9(5).
             05 KLV-NBOL  PIC 9.
             05 KLV-NUBOL PIC 9(5).
             05 KLV-PRGN  PIC 9(5).
      ************
           COPY 'grinta'.
           COPY 'grimri'.
           COPY 'grimti'.
           COPY 'grib2s'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'gritabrk'.
           COPY 'grit35rk'.
           COPY 'griordrk'.
      **** rel 7.2
           COPY 'grij02rk'.
           COPY 'gribktrk'.
      ************
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parbc'.
           COPY 'pardag'.
           COPY 'parg'.
           COPY 'parrb'.
           COPY 'parsx'.
           COPY 'parwxml-2-72'.
      **** rel 7.2
      *    COPY 'parwtxt'.
      ************
           COPY 'parmb'.
      **** rel 7.1
           COPY 'pariban'.
      ************
      **** rel 7.2
           COPY 'parag'.
           COPY 'parrd'.
           COPY 'prfisc'.
           COPY 'prpiva'.
           COPY 'parul'.
           COPY 'pardsps'.
           COPY 'parpcfa'.
           COPY 'parer'.
           COPY 'parfper'.
      ************
       01  PAR-D-MDT.
           05 D-MDT-AZI  PIC 999.
           05 D-MDT-TDOC PIC 9.
           05 D-MDT-KEY  PIC X(15).
       01  ID-AZI  PIC X(15) VALUE 'anaazi'.
       01  ID-BCT  PIC X(15) VALUE 'bolcte'.
       01  ID-BCR  PIC X(15) VALUE 'bolcri'.
       01  ID-FAT  PIC X(15) VALUE 'fattur'.
       01  ID-CLF  PIC X(15) VALUE 'anaclf'.
       01  ID-TAB  PIC X(15) VALUE 'tabell'.
       01  ID-ARI  PIC X(15) VALUE 'apprig'.
       01  ID-ACT  PIC X(15) VALUE 'appbct'.
       01  ID-AFT  PIC X(15) VALUE 'appfat'.
       01  ID-TFE  PIC X(15) VALUE 'tabfel'.
       01  ID-AAZ  PIC X(15) VALUE 'appazi'.
       01  ID-ORD  PIC X(15) VALUE 'ordcli'.
       01  ID-NCR  PIC X(15) VALUE 'notbcr'.
       01  ID-ACF  PIC X(15) VALUE 'appclf'.
      **** rel 7.1
       01  ID-BAN PIC X(15) VALUE 'anaban'.
       01  ID-ABA PIC X(15) VALUE 'appban'.
      ************
      **** rel 7.2
       01  ID-ALG PIC X(15) VALUE 'allega'.
       01  ID-SPS PIC X(15) VALUE 'spesog'.
       01  ID-B2A PIC X(15) VALUE 'b2bart'.
       01  ID-SST PIC X(15) VALUE 'spetab'.
       01  ID-BKT PIC X(15) VALUE 'blktab'.
       01  ID-B2P PIC X(15) VALUE 'b2btpa'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-SPI PIC X(15) VALUE 'speiva'.
       01  ID-NTA PIC X(15) VALUE 'nottab'.
       01  ID-MTI PIC X(15) VALUE 'mestit'.
       01  ID-MRI PIC X(15) VALUE 'mesrig'.
       01  ID-B2S PIC X(15) VALUE 'b2bspe'.
       01  ID-AIM PIC X(15) VALUE 'anaimb'.
       01  ID-PBR PIC X(15) VALUE 'probcr'.
       01  ID-WSI PIC X(15).
      ************
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-BCT   PIC XX.
           05 SF-BCR   PIC XX.
           05 SF-FAT   PIC XX.
           05 SF-CLF   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-ARI   PIC XX.
           05 SF-ACT   PIC XX.
           05 SF-AFT   PIC XX.
           05 SF-TFE   PIC XX.
           05 SF-AAZ   PIC XX.
           05 SF-ORD   PIC XX.
           05 SF-NCR   PIC XX.
           05 SF-ACF   PIC XX.
      **** rel 7.1
           05 SF-BAN  PIC XX.
           05 SF-ABA  PIC XX.
      ************
      **** rel 7.2
           05 SF-ALG  PIC XX.
           05 SF-SPS  PIC XX.
           05 SF-SST  PIC XX.
           05 SF-B2A  PIC XX.
           05 SF-BKT  PIC XX.
           05 SF-B2P  PIC XX.
           05 SF-LAV  PIC XX.
           05 SF-SPI  PIC XX.
           05 SF-NTA  PIC XX.
           05 SF-MTI  PIC XX.
           05 SF-MRI  PIC XX.
           05 SF-B2S  PIC XX.
           05 SF-WSI  PIC XX.
           05 SF-AIM  PIC XX.
           05 SF-PBR  PIC XX.
      ************
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 DAT1     PIC 9(5).
           05 DAT2     PIC 9(5).
           05 K        PIC 9(3).
           05 K1       PIC 99.
      **** rel 7.2
           05 K3       PIC 999.
           05 ENDFILE PIC 999.
           05 LUNGNOME PIC 999.
           05 NOMEFILE PIC X(150).
           05 CARTELLA PIC X(100).
           05 INUIVA   PIC 99999.
           05 RITE      PIC S9(11)V99 VALUE ZERO.
           05 IMPO      PIC S9(11)V99 VALUE ZERO.
           05 PERRIT    PIC S9(11)V99 VALUE ZERO.
           05 COM-ALIVA PIC 9(3)V99   VALUE ZERO.
           05 COM-PRG   PIC ZZZZ9.
           05 IMBOL PIC 9(5)V99.
           05 IMPSC PIC 9(7)V99.
           05 COM-VSORD PIC X(10).
           05 COM-NUM   PIC 9(5).
           05 COM-DTORD PIC 9(5).
           05 DIFFERENZA PIC S9(11)V999999 VALUE ZERO.
           05 PERCENTUA  PIC S9(11)V999999 VALUE ZERO.
           05 SCESC   PIC 9     VALUE ZERO.
           05 SDISC   PIC 9     VALUE ZERO.
           05 KU1 PIC 9(5) VALUE ZERO.
           05 KU2 PIC 9(5) VALUE ZERO.
           05 COMCDIVA PIC 9(3) VALUE ZERO.
           05 INDICE   PIC 999.
           05 ULTIND   PIC 999.
           05 IMPIMB   PIC 9(11)V99.
           05 PREPAL   PIC 9(5).
           05 PRECOL   PIC 9(5).
           05 PREIMB   PIC X(12).
           05 COMNIMB  PIC 9(3).
           05 VETIMB   PIC X(12) OCCURS 30.
           05 VETQTA   PIC 9(5)  OCCURS 30.
           05 COMEURO  PIC 9(3).
           05 COMPRZ1  PIC S9(11)V9(7).
           05 COMPRZ2  PIC S9(11)V9(7).
      ************
           05 ESTPIVA  PIC 9.
           05 COMNOTE PIC X(500) VALUE SPACE.
           05 FLGTES PIC 9 VALUE ZERO.
           05 CODCLI.
              10 CMAS   PIC 9(2).
              10 CCOD   PIC 9(5).
           05 POSIZ PIC 9.
           05 OLDPROG PIC X(5).
           05 PROG PIC X(5).
           05 PROGC REDEFINES PROG.
              10 PROGN PIC X OCCURS 5.
           05 NUMFAT   PIC 9(5).
           05 NUMFATA    REDEFINES NUMFAT PIC ZZZZ9.
           05 COMNUM   PIC 9(10)V9(6).
           05 CONT     PIC 9(5).
           05 CONT2    PIC 9(5).
           05 K2       PIC 9(5).
           05 COMCFISC PIC X(16).
           05 NFAT     PIC 9(5).
           05 NFATA    REDEFINES NFAT PIC ZZZZ9.
           05 ULFAT    PIC 9(5).
           05 ULFATA   REDEFINES ULFAT PIC ZZZZ9.
           05 FLGORD   PIC 9.
           05 FLGBCT   PIC 9.
           05 SAVNUM   PIC 9.
           05 SAVBCT   PIC 9(5).
           05 IMPRIT   PIC S9(11)V9(6).
           05 SAVORD   PIC 9(5).
           05 SAVALIVA  PIC 9(3).
           05 SAVNATURA PIC X(2).
           05 COMVALUT PIC X(3).
      **** rel 7.1
           05 D-IBAN   PIC X(27).
           05 D-ABI    PIC X(5).
           05 D-CAB    PIC X(5).
      **** rel 7.2
      *    05 COM-DESC PIC X(100).
           05 COM-DESC PIC X(500).
           05 ALG-KEY.
              10 AF-NUM PIC 9.
              10 AF-BOL PIC 9(5).
              10 AF-CATT PIC X.
           05 FLGNOPAG PIC 9.
           05 CONTROLLOK PIC 9.
           05 ESTEROSINO  PIC 9.
           05 COM-NAZIONE PIC X(3).
           05 SAV-KEYULT PIC X(12).
      *
           05 CDIVA    PIC 9(3)V99 OCCURS 6.
           05 IMPON    PIC S9(11)V9(7) OCCURS 6.
      **** rel 7.2
           05 CDIVA2   PIC 9(3)V99 OCCURS 6.
           05 SPES     PIC S9(11)V9(7) OCCURS 6.
           05 SPESAC   PIC 9.
           05 SAVPRZ2  PIC S9(11)V9(7).
      ************
           05 SAVPRZ   PIC S9(10)V9(6).
           05 IND      PIC 9.
           05 SCONTO   PIC 999V99 VALUE ZERO.
           05 SCONXX   PIC X(6).
           05 CALCNUM  PIC S9(11)V9(7).
           05 IVABL    PIC 9(3).
           05 IVABA    PIC 9(3).
       01  NNN-X.
           05 FILLER PIC X VALUE 'N'.
           05 FILLER PIC X VALUE 'M'.
      *---------------------------------------------------------
      * Parametri X"91" function 69 (scan dir)
       01  RESULT.
           05 F-ERROR      PIC X     COMP-X.
           05 F-HANDLE     PIC X(2)  COMP-X.
           05 F-ATTROUT    PIC X     COMP-X.
           05 F-TIME       PIC X(2)  COMP-X.
           05 F-DATE       PIC X(2)  COMP-X.
           05 F-SIZE       PIC X(4)  COMP-X.
           05 F-FILEOUT    PIC X(60).
       01  FUNCTION-CODE   PIC X     COMP-X VALUE 69.
       01  PARAMETER.
           05 F-ACTION     PIC X     COMP-X.
           05 F-ATTRIN     PIC X     COMP-X.
           05 F-FILEIN     PIC X(60).
      *---------------------------------------------------------
      * Parametri CBL_CREATE_DIR, CBL_DELETE_DIR, CBL_CHANGE_DIR
       01  PATH-NAME           PIC X(60).
       01  STATUS-CODE         PIC X(2)   COMP-X.
      *---------------------------------------------------------
      * Parametri CBL_COPY_FILE, CBL_DELETE_FILE
       01  FILE-NAME           PIC X(60).
       01  FILE-OUT            PIC X(60).
      *01  STATUS-CODE         PIC X(2)   COMP-X.
      *---------------------------------------------------------
      * Parametri CBL_GET_CURRENT_DIR
       01  FLAGS               PIC X(4) COMP-5.
       01  NAME-LENGTH         PIC X(4) COMP-5.
       01  DIRECTORY-NAME      PIC X(60).
      *01  STATUS-CODE         PIC X(2) COMP-X.
      *---------------------------------------------------------
      ************
       01  PAR-P-MDT.
           05 P-MDT-AZI   PIC 999.
           05 P-MDT-TDOC  PIC 9.
           05 P-MDT-KEY   PIC X(15).
           05 P-MDT-FLGS  PIC 9.
           05 P-MDT-DATA  PIC 9(5).
           05 P-MDT-NCOL  PIC 99.
           05 P-MDT-TESTO PIC X(76).
           05 P-MDT-FLGE  PIC 9.
      *
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-CATT      PIC X.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D  PIC X(36).
           05 IF-TPDOC-1   PIC 9.
           05 IF-TPDOC-2   PIC 9.
           05 IF-COD-1     PIC 9(5).
           05 IF-COD-2     PIC 9(5).
           05 IF-CLI-1     PIC 9(5).
           05 IF-CLI-2     PIC 9(5).
           05 IF-DAT-1     PIC 9(6).
           05 IF-DAT-2     PIC 9(6).
           05 IF-PERC      PIC X(100).
           05 IF-ATT       PIC X.
           05 IF-ATT-D     PIC X(24).
           05 IF-PROG      PIC X(5).
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclbct'.
           COPY 'dclbcr'.
           COPY 'dclfat'.
           COPY 'dclclf'.
           COPY 'dcltab'.
           COPY 'dclact'.
           COPY 'dclaft'.
           COPY 'dcltfe'.
           COPY 'dclaaz'.
           COPY 'dclord'.
           COPY 'dclncr'.
           COPY 'dclacf'.
      **** rel 7.1
           COPY 'dclban'.
           COPY 'dclaba'.
      ************
      **** rel 7.2
           COPY 'dclalg'.
           COPY 'dclsps'.
           COPY 'dclsst'.
           COPY 'dclb2a'.
           COPY 'dclbkt'.
           COPY 'dclb2p'.
           COPY 'dcllav'.
           COPY 'dclspi'.
           COPY 'dclnta'.
           COPY 'dclmri'.
           COPY 'dclmti'.
           COPY 'dclb2s'.
           COPY 'dclaim'.
           COPY 'dclwsi'.
           COPY 'dclpbr'.
      ************
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vfat500: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI BOLCTE BOLCRI FATTUR
                 ANACLF TABELL APPBCT TABFEL
                 APPFAT APPAZI ORDCLI NOTBCR
                 APPCLF.
      **** rel 7.1
           CLOSE ANABAN APPBAN.
      ************
      **** rel 7.2
           CLOSE ALLEGA.
      ************
           CLOSE NOTTAB.
           CLOSE MESTIT.
           CLOSE MESRIG.
           CLOSE B2BSPE.
      **** rel 7.2
           CLOSE SPESOG.
           CLOSE B2BART.
           CLOSE SPETAB.
           CLOSE BLKTAB.
           CLOSE SPEIVA.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
      *
           CLOSE PROBCR.
           CLOSE ANAIMB.
           CLOSE WDSSIB.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
      ************
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gribcter'.
           COPY 'gribcrer'.
           COPY 'grifater'.
           COPY 'griclfer'.
           COPY 'gritaber'.
           COPY 'griacter'.
           COPY 'griafter'.
           COPY 'gritfeer'.
           COPY 'griaazer'.
           COPY 'griorder'.
           COPY 'grincrer'.
           COPY 'griacfer'.
      **** rel 7.1
           COPY 'gribaner'.
           COPY 'griabaer'.
      ************
      **** rel 7.2
           COPY 'grialger'.
      ************
      **** rel 7.2
           COPY 'grispser'.
           COPY 'grib2aer'.
           COPY 'grisster'.
           COPY 'gribkter'.
           COPY 'grib2per'.
           COPY 'grispier'.
           COPY 'grintaer'.
           COPY 'grimrier'.
           COPY 'grimtier'.
           COPY 'grib2ser'.
           COPY 'griaimer'.
           COPY 'gripbrer'.
      ************
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           OPEN INPUT ANAAZI
                      ANACLF
                      TABELL
                      APPBCT
      **** rel 7.2
      *               APPFAT
      ************
                      APPAZI
                      ORDCLI
                      NOTBCR
      **** rel 7.1
                      ANABAN 
                      APPBAN
      ************
      **** rel 7.2
                      ALLEGA
      ************
                      APPCLF
      **** rel 7.2
                      SPESOG
                      B2BART
                      SPETAB
                      BLKTAB
                      B2BTPA
                      SPEIVA
                      NOTTAB
                      MESTIT
                      MESRIG
                      B2BSPE
                      ANAIMB
                      PROBCR
      ************
                      BOLCRI.
           OPEN I-O TABFEL BOLCTE.
      **** rel 7.2
           OPEN I-O APPFAT.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
      *
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
           OPEN I-O WDSSIB.
      ************
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                                GO TO ERRIO.
           MOVE KEYAZ TO KEYAAZ.
           READ APPAZI.
           IF SF-AAZ NOT = ZERO 
              MOVE ZERO  TO RF-AAZ AAZ-DNA
              MOVE SPACE TO AAZ-RGSOC AAZ-CNA AAZ-PNA 
                            AAZ-SES
              MOVE KAZ-COD TO KAAZ-COD.
      *
           MOVE SPACE TO COMCFISC.
           IF AZI-CFISC = SPACE
              MOVE AZI-PIVA TO COMCFISC
           ELSE
              MOVE AZI-CFISC TO COMCFISC.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO CMAS.
           MOVE KAZ-COD TO KTFE-AZI. 
           READ TABFEL INVALID
                PERFORM INVK-TFE
                GO TO ERRIO.
      *
      **** rel 7.2
           MOVE 14011 TO KEYTB.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-SCESC TO SCESC.
           MOVE T14-SDISC TO SDISC.
      *
           MOVE 14 TO KTB-TIP.
           MOVE 1 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-IVABL TO IVABL.
           MOVE T14-IVABA TO IVABA.
      *
           MOVE 14 TO KTB-TIP.
           MOVE 3 TO KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY
                PERFORM INVK-TAB
                GO TO WARNING.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-IMBOL TO IMBOL.
           MOVE T14-IMPSC TO IMPSC.
      *
           CALL 'rveur' USING COMEURO.
      *************
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.
      **** rel 7.2
      *    MOVE 1       TO IF-TPDOC.
      *    MOVE ZERO    TO IF-COD-1
      *                    IF-COD-2.
      *    MOVE ZERO    TO IF-CLI-1
      *                    IF-DAT-1.
      *    MOVE 99999   TO IF-CLI-2.
      *    ACCEPT GGMMAA FROM DATE.
      *    MOVE GG9 TO AAGGG.
      *    MOVE AA9 TO GG9.
      *    MOVE AAGGG TO AA9.
      *    MOVE GGMMAA TO IF-DAT-2.
      ************
           MOVE TFE-PERC TO IF-PERC.
      **** rel 7.2
      *    MOVE IF-CATT  TO IF-ATT.
      ************
           MOVE IF-ATT TO T35-CATT.
           MOVE 35     TO T35-TIP.
           MOVE IF-AZI TO T35-CDAZ.
           MOVE T35-KEYID  TO KEYTB.
           READ TABELL INTO REKT35 INVALID
                MOVE ALL '*' TO T35-DATT.
           MOVE T35-DATT TO IF-ATT-D.
           IF IF-ATT = ZERO
              MOVE 'ATTIVITA'' PRINCIPALE' TO IF-ATT-D.
           MOVE TFE-PROG TO IF-PROG.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
       V-TPDOC-2.
           MOVE 'IF-TPDOC-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPDOC-2.
           IF IF-TPDOC-1 = ZERO
              MOVE 1 TO IF-TPDOC-1.
           IF IF-TPDOC-2 = ZERO
              MOVE 9 TO IF-TPDOC-2.
           IF IF-TPDOC-1 > IF-TPDOC-2
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-TPDOC-2.
      *
       V-COD-1.
           MOVE 'IF-COD-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-1.
       E-COD-1.
      *
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-COD-2 < IF-COD-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD-2.
      *
       V-CLI-1.
           MOVE 'IF-CLI-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CLI-1.
       E-CLI-1.
      *
       V-CLI-2.
           MOVE 'IF-CLI-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CLI-2.
           IF IF-CLI-2 < IF-CLI-1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-CLI-2.
      *
       V-ATT.
           MOVE 'IF-ATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ATT.
           MOVE SPACE TO IF-ATT-D.
      *
           MOVE IF-ATT TO T35-CATT.
           MOVE 35     TO T35-TIP.
           MOVE IF-AZI TO T35-CDAZ.
           MOVE T35-KEYID  TO KEYTB.
           READ TABELL INTO REKT35 INVALID
                MOVE ALL '*' TO T35-DATT.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE T35-DATT TO IF-ATT-D.
           IF IF-ATT = ZERO
              MOVE 'ATTIVITA'' PRINCIPALE' TO IF-ATT-D.
      **** rel 7.2
      *    IF T35-FELE = ZERO
      *       MOVE 'Su questo codice attivit non          ' TO F-MES1
      *       MOVE 'possibile generare fatture elettroniche ' TO F-MES2
      *       MOVE 2 TO F-NMES
      *       GO TO V-ERROR.
      ************
       E-ATT.
      *
       V-DAT-1.
           MOVE 'IF-DAT-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DAT-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DAT-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 = 1
              MOVE ZERO TO DAT1
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DAT-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG      TO DAT1.
       E-DAT-1.
      *
       V-DAT-2.
           MOVE 'IF-DAT-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DAT-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DAT-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 = 1
              MOVE ZERO TO IF-DAT-2
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DAT-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG  TO DAT2.
           IF DAT2 < DAT1
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-DAT-2.
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           CLOSE FATTUR.
           IF IF-ATT NOT = ZERO
              STRING 'fattur' IF-ATT DELIMITED SPACE INTO ID-FAT.
           OPEN INPUT FATTUR.
      *
           MOVE SPACE TO OLDPROG.
           MOVE TFE-PROG TO PROG.
      *
      **** rel 7.2
           MOVE IF-AZI    TO PFPER-AZI.
           MOVE IF-ATT    TO PFPER-CATT.
           MOVE ZERO        TO PFPER-KEYFT.
           MOVE ZERO        TO PFPER-KEYCR.
           MOVE ZERO        TO PFPER-TIPO.
           MOVE SPACE       TO PFPER-NFILE.
           MOVE ZERO        TO PFPER-CONT.
           MOVE ZERO        TO PFPER-SCRIVI.
           MOVE ZERO        TO PFPER-SAVALIVA.
           MOVE SPACE       TO PFPER-SAVNATURA.
           CALL 'vrcfper' USING PARFPER PARWXML.
      ************
           MOVE ZERO TO KEYFT ULFAT NFAT.
       INIZ.
           MOVE KAZ-COD  TO KFT-AZI.
           MOVE IF-TPDOC-1 TO KFT-TDOC.
       RESTART.
           MOVE IF-COD-1 TO KFT-NUM.
       RDFAT.
           START FATTUR KEY NOT < KEYFT INVALID GO TO ENDFAT.
       NEWFAT.
           READ FATTUR NEXT AT END GO TO ENDFAT.
           IF SF-FAT = '9D' OR '9A' OR '35' GO TO NEWFAT.
           IF KFT-AZI  > KAZ-COD  GO TO ENDFAT.
           IF KFT-TDOC > IF-TPDOC-2 GO TO ENDFAT.
           IF KFT-NUM  < IF-COD-1 GO TO RESTART.
           IF KFT-NUM  > IF-COD-2 
              ADD 1 TO KFT-TDOC
              GO TO RESTART.
           IF FAT-CDCLI < IF-CLI-1 OR > IF-CLI-2 GO TO NEWFAT.
           IF FAT-DATA  < DAT1 OR > DAT2         GO TO NEWFAT.
      **** rel 7.2
      *    IF FAT-CATT NOT = IF-ATT              GO TO NEWFAT.
      ************
      *
      **** rel 7.2
      *    MOVE KFT-AZI  TO KAFT-AZI.
      *    MOVE KFT-TDOC TO KAFT-TDOC.
      *    MOVE KFT-NUM  TO KAFT-NUM.
      *    MOVE FAT-CATT TO KAFT-CATT.
      *    READ APPFAT INVALID 
      *         GO TO NEWFAT.
      ************
      *
      **** rel 7.1
           MOVE FAT-CDBAN TO KBA-BAN.
           READ ANABAN INVALID KEY MOVE SPACE TO BAN-RGSOC
                                                 BAN-CODAZ
                                                 BAN-CODSP.
           MOVE KFT-AZI TO KABA-AZI.
           MOVE KBA-BAN TO KABA-BAN.
           READ APPBAN INVALID MOVE SPACE TO ABA-CIBAN.
      *
      ************
           MOVE FAT-CDCLI TO CCOD.
           MOVE KAZ-COD   TO KCF-AZI.
           MOVE CODCLI    TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID KEY
                  GO TO NEWFAT.
      **** rel 7.2
           MOVE KEYCF TO KEYSPS.
           READ SPESOG INVALID MOVE SPACE TO RF-SPS
                               MOVE ZERO  TO SPS-FADTORD SPS-STAB-CAP
                                          MOVE HIGH-VALUE TO SPS-PIVA
                                          MOVE HIGH-VALUE TO SPS-CFISC.
      ************
           MOVE KEYCF TO KEYACF.
           READ APPCLF INVALID MOVE SPACE TO ACF-NAZIO.
      *
      **** rel 7.2
           MOVE KFT-AZI  TO KAFT-AZI.
           MOVE KFT-TDOC TO KAFT-TDOC.
           MOVE KFT-NUM  TO KAFT-NUM.
           MOVE FAT-CATT TO KAFT-CATT.
           READ APPFAT INVALID 
                MOVE KFT-AZI  TO KAFT-AZI
                MOVE KFT-TDOC TO KAFT-TDOC
                MOVE KFT-NUM  TO KAFT-NUM
                MOVE FAT-CATT TO KAFT-CATT
                MOVE SPS-CODICEUFFI TO AFT-IPA
                MOVE SPS-CIG        TO AFT-CIG
                MOVE SPS-CUP        TO AFT-CUP
                MOVE ZERO           TO AFT-TIPO
                MOVE SPS-FAORD      TO AFT-FAORD
                MOVE SPS-FADTORD    TO AFT-FADTORD
                MOVE ZERO           TO AFT-MCIVA
                MOVE SPACE          TO AFT-TIPOD
                MOVE ZERO           TO AFT-XML
                MOVE SPS-CODICEDEST TO AFT-DEST
                MOVE SPS-PEC        TO AFT-PEC.
      **** rel 7.2
           IF AFT-IPA = ZERO
              MOVE SPS-CODICEUFFI TO AFT-IPA.
           IF AFT-CIG = SPACE
              MOVE SPS-CIG        TO AFT-CIG.
           IF AFT-CUP = SPACE 
              MOVE SPS-CUP        TO AFT-CUP.
           IF AFT-FAORD = SPACE
              MOVE SPS-FAORD      TO AFT-FAORD.
           IF AFT-FADTORD = ZERO
              MOVE SPS-FADTORD    TO AFT-FADTORD.
           IF AFT-DEST = SPACE OR
              AFT-DEST = '0000000' OR
              AFT-DEST = LOW-VALUE OR
              AFT-DEST = HIGH-VALUE
              MOVE SPS-CODICEDEST TO AFT-DEST.
           IF AFT-PEC = SPACE OR 
              AFT-PEC = ALL '0' OR
              AFT-PEC = LOW-VALUE OR
              AFT-PEC = HIGH-VALUE
              MOVE SPS-PEC        TO AFT-PEC.
      ************
      *
           MOVE ZERO TO ESTEROSINO.
      *
           MOVE ZERO TO PARDSPS.
           MOVE KCF-AZI   TO PDSPS-AZI.
           MOVE 'C'       TO PDSPS-CFGO.
           MOVE FAT-CDCLI TO PDSPS-SOG.
           CALL 'vrcdsps' USING PARDSPS.
           IF PDSPS-NAZ NOT = 'IT'
              MOVE 1 TO ESTEROSINO.
      ************
      *
           CALL 'rdbfa' USING FAT-CATT KEYFT PARRB.
      *
           PERFORM DL-LAV-IMB THRU EX-DL-LAV-IMB.
      *
      * controllo se la bolla  gia stata esportata
           MOVE KFT-AZI    TO KBC-AZI.
           MOVE RB-TNUM(1) TO KBC-NUM.
           MOVE RB-NBOL(1) TO KBC-BOL.
           READ BOLCTE INVALID GO TO NEWFAT.
      **** rel 7.2
      *    IF BCT-XML NOT = ZERO GO TO NEWFAT.
           IF AFT-XML IS NUMERIC
              IF AFT-XML NOT = ZERO GO TO NEWFAT.
      ************
      *
      *    ADD 1 TO PROG.
           MOVE PROG TO OLDPROG. 
           PERFORM INCR-PROG THRU EX-INCR-PROG.
      *
      **** rel 7.2
           MOVE ZERO TO IND.
       AZZ-IMPO.
           ADD 1 TO IND.
           MOVE ZERO TO CDIVA(IND)
      **** rel 7.2
      *                 IMPON(IND).
                        IMPON(IND)
                        CDIVA2(IND)
                        SPES(IND).
      ************
           IF IND < 6 GO TO AZZ-IMPO.  
      
           MOVE FAT-CDPAG TO KTB-COD.
           MOVE 4 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE ZERO TO T04-SCASS.
           MOVE T04-SCASS TO SCONTO.
      ************
           IF TFE-EXPEST = 1 OR
              ESTEROSINO = ZERO
              PERFORM ESPORTA-HEADER THRU EX-ESPORTA-HEADER
              PERFORM CERCA-ORD THRU EX-CERCA-ORD
              PERFORM INIZIO-BODY THRU EX-INIZIO-BODY.
           MOVE ZERO  TO K CONT.
      **** rel 7.2
           MOVE KFT-AZI     TO PFPER-AZI.
           MOVE FAT-CATT    TO PFPER-CATT.
           MOVE KEYFT       TO PFPER-KEYFT.
           MOVE ZERO        TO PFPER-KEYCR.
           MOVE 1           TO PFPER-TIPO.
           MOVE PWXM-NOMEFX TO PFPER-NFILE.
           MOVE CONT        TO PFPER-CONT.
           MOVE 1           TO PFPER-SCRIVI.
           MOVE SAVALIVA    TO PFPER-SAVALIVA.
           MOVE SAVNATURA   TO PFPER-SAVNATURA.
           CALL 'vrcfper' USING PARFPER PARWXML.
           MOVE PFPER-CONT TO CONT.
      ************
       ALTRABOLLA.
           ADD 1 TO K.
           IF RB-TNUM(K) = ZERO OR
              RB-NBOL(K) = ZERO
              GO TO BASTABOLLA.
      *
           MOVE KFT-AZI    TO KBC-AZI.
           MOVE RB-TNUM(K) TO KBC-NUM.
           MOVE RB-NBOL(K) TO KBC-BOL.
           READ BOLCTE INVALID GO TO ALTRABOLLA.
      *
      **** rel 7.2
           MOVE KFT-AZI     TO PFPER-AZI.
           MOVE FAT-CATT    TO PFPER-CATT.
           MOVE KEYFT       TO PFPER-KEYFT.
           MOVE ZERO        TO PFPER-KEYCR.
           MOVE KFT-AZI     TO PFPER-KCR-AZI.
           MOVE RB-TNUM(K)  TO PFPER-KCR-NUM.
           MOVE RB-NBOL(K)  TO PFPER-KCR-BOL.
           MOVE 2           TO PFPER-TIPO.
           MOVE PWXM-NOMEFX TO PFPER-NFILE.
           MOVE CONT        TO PFPER-CONT.
           MOVE 1           TO PFPER-SCRIVI.
           MOVE SAVALIVA    TO PFPER-SAVALIVA.
           MOVE SAVNATURA   TO PFPER-SAVNATURA.
           CALL 'vrcfper' USING PARFPER PARWXML.
           MOVE PFPER-CONT TO CONT.
      ************
           MOVE KFT-AZI    TO KCR-AZI.
           MOVE RB-TNUM(K) TO KCR-NUM.
           MOVE RB-NBOL(K) TO KCR-BOL.
           MOVE ZERO       TO KCR-PGR. 
           START BOLCRI KEY NOT < KEYCR INVALID GO TO ENDBCR.
       NEWBCR.
           READ BOLCRI NEXT AT END GO TO ENDBCR.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO NEWBCR.
           IF KCR-AZI > KFT-AZI    GO TO ENDBCR.
           IF KCR-NUM > RB-TNUM(K) GO TO ENDBCR.
           IF KCR-BOL > RB-NBOL(K) GO TO ENDBCR.
           IF BCR-DESCR = SPACE
              GO TO NEWBCR.
           IF BCR-TCOR = 1 AND BCR-FSC  = 2 GO TO NEWBCR.
      *    IF BCR-TCOR = 1 GO TO NEWBCR. 
           IF TFE-EXPEST = ZERO
              IF ESTEROSINO = 1 GO TO ENDBCR.
      *
      **** rel 7.2
           MOVE KFT-AZI     TO PFPER-AZI.
           MOVE FAT-CATT    TO PFPER-CATT.
           MOVE KEYFT       TO PFPER-KEYFT.
           MOVE KEYCR       TO PFPER-KEYCR.
           MOVE 3           TO PFPER-TIPO.
           MOVE PWXM-NOMEFX TO PFPER-NFILE.
           MOVE CONT        TO PFPER-CONT.
           MOVE 1           TO PFPER-SCRIVI.
           MOVE SAVALIVA    TO PFPER-SAVALIVA.
           MOVE SAVNATURA   TO PFPER-SAVNATURA.
           CALL 'vrcfper' USING PARFPER PARWXML.
           MOVE PFPER-CONT TO CONT.
      ************
           ADD 1 TO CONT.
           PERFORM ESPORTA-DATI-BODY THRU EX-ESPORTA-DATI-BODY.
      **** rel 7.2
           MOVE KFT-AZI     TO PFPER-AZI.
           MOVE FAT-CATT    TO PFPER-CATT.
           MOVE KEYFT       TO PFPER-KEYFT.
           MOVE KEYCR       TO PFPER-KEYCR.
           MOVE 4           TO PFPER-TIPO.
           MOVE PWXM-NOMEFX TO PFPER-NFILE.
           MOVE CONT        TO PFPER-CONT.
           MOVE 1           TO PFPER-SCRIVI.
           MOVE SAVALIVA    TO PFPER-SAVALIVA.
           MOVE SAVNATURA   TO PFPER-SAVNATURA.
           CALL 'vrcfper' USING PARFPER PARWXML.
           MOVE PFPER-CONT TO CONT.
      ************
      **** rel 7.2
           IF BCT-IMB = 1 PERFORM WR-LAV-IMB THRU EX-WR-LAV-IMB.
      ************
      *
           GO TO NEWBCR.
       ENDBCR.
      *
           MOVE 1 TO BCT-XML.
           REWRITE RF-BCT INVALID PERFORM INVK-BCT
                                  GO TO ERRIO.
      **** rel 7.2
           MOVE 1 TO AFT-XML.
           IF TFE-EXPEST = ZERO
              IF ESTEROSINO = 1
                 MOVE OLDPROG TO PROG
                 MOVE 8 TO AFT-XML.
           IF AFT-IPA = SPACE
              MOVE SPS-CODICEUFFI  TO AFT-IPA.
           IF AFT-DEST = SPACE OR
              AFT-DEST = '0000000'
              MOVE SPS-CODICEDEST  TO AFT-DEST.
           IF AFT-PEC = SPACE OR 
              AFT-PEC = ALL '0' OR
              AFT-PEC = LOW-VALUE OR
              AFT-PEC = HIGH-VALUE
              MOVE SPS-PEC  TO AFT-PEC.
      *
           IF AFT-CIG = SPACE
              MOVE SPS-CIG  TO AFT-CIG.
           IF AFT-CUP = SPACE
              MOVE SPS-CUP  TO AFT-CUP.
           IF AFT-FAORD = SPACE
              MOVE SPS-FAORD  TO AFT-FAORD.
           IF AFT-FADTORD = ZERO
              MOVE SPS-FADTORD  TO AFT-FADTORD.
      *
           MOVE SPACE TO AFT-PROG.
           IF AFT-XML NOT = 8
              MOVE PROG TO AFT-PROG.
           REWRITE RF-AFT INVALID
               WRITE RF-AFT INVALID PERFORM INVK-AFT
                                  GO TO ERRIO.
      ************
      **** rel 7.2
           MOVE KFT-AZI     TO PFPER-AZI.
           MOVE FAT-CATT    TO PFPER-CATT.
           MOVE KEYFT       TO PFPER-KEYFT.
           MOVE KEYCR       TO PFPER-KEYCR.
           MOVE 5           TO PFPER-TIPO.
           MOVE PWXM-NOMEFX TO PFPER-NFILE.
           MOVE CONT        TO PFPER-CONT.
           MOVE 1           TO PFPER-SCRIVI.
           MOVE SAVALIVA    TO PFPER-SAVALIVA.
           MOVE SAVNATURA   TO PFPER-SAVNATURA.
           CALL 'vrcfper' USING PARFPER PARWXML.
           MOVE PFPER-CONT TO CONT.
      ************
           GO TO ALTRABOLLA.
       BASTABOLLA.
      **** rel 7.2
           IF FAT-SPBAN = ZERO GO TO NO-SPBAN-PAG.
           MOVE ZERO TO IND.
       NO-SPBAN-PAG-0.
           ADD 1 TO CONT.
      *
      * Inizio DettaglioLinee x Sconto Pagamento
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DettaglioLinee' TO PWXM-TAG.
           MOVE SPACE TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'NumeroLinea' TO PWXM-TAG.
           MOVE CONT TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'TipoCessionePrestazione' TO PWXM-TAG.
           MOVE 'AC' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           STRING 'SPESE BANCA' DELIMITED SIZE INTO PWXM-CAMPO.
           MOVE 'Descrizione' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'PrezzoUnitario' TO PWXM-TAG.
           MOVE FAT-SPBAN TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           IF FAT-SPBAN < ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO
              ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'PrezzoTotale' TO PWXM-TAG.
           MOVE FAT-SPBAN TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           IF FAT-SPBAN < ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO
              ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
      **** rel 7.2
           MOVE COMNUM TO SAVPRZ2.
      ************
           MOVE 'AliquotaIVA' TO PWXM-TAG.
      **** rel 7.2
      *    MOVE IVABA TO KTB-COD.
           IF FAT-CDESE = ZERO
              MOVE IVABA TO KTB-COD COMCDIVA
           ELSE
              MOVE FAT-CDESE TO KTB-COD COMCDIVA.
      ************
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE ZERO TO T03-ALIVA.
           MOVE T03-ALIVA TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           PERFORM NATURA THRU EX-NATURA.
      *
      **** rel 7.2
           PERFORM SPESEAC THRU EX-SPESEAC.
      ************
      * Fine DettaglioLinee
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       NO-SPBAN-PAG.
           IF FAT-SPBOL = ZERO GO TO NO-SPBOL-PAG.
           MOVE ZERO TO IND.
       NO-SPBOL-PAG-0.
           ADD 1 TO CONT.
      *
      * Inizio DettaglioLinee x Sconto Pagamento
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DettaglioLinee' TO PWXM-TAG.
           MOVE SPACE TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'NumeroLinea' TO PWXM-TAG.
           MOVE CONT TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'TipoCessionePrestazione' TO PWXM-TAG.
           MOVE 'AC' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           STRING 'ADDEBITO BOLLO' DELIMITED SIZE INTO PWXM-CAMPO.
           MOVE 'Descrizione' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'PrezzoUnitario' TO PWXM-TAG.
           MOVE FAT-SPBOL TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           IF FAT-SPBOL < ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO
              ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'PrezzoTotale' TO PWXM-TAG.
           MOVE FAT-SPBOL TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           IF FAT-SPBOL < ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO
              ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
      **** rel 7.2
           MOVE COMNUM TO SAVPRZ2.
      ************
           MOVE 'AliquotaIVA' TO PWXM-TAG.
           MOVE IVABL TO KTB-COD COMCDIVA.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE ZERO TO T03-ALIVA.
           MOVE T03-ALIVA TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           PERFORM NATURA THRU EX-NATURA.
      *
      **** rel 7.2
           PERFORM SPESEAC THRU EX-SPESEAC.
      ************
      * Fine DettaglioLinee
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       NO-SPBOL-PAG.
      ************
      *
           IF TFE-EXPEST = ZERO AND
              ESTEROSINO = 1
              GO TO NOEXP.
           PERFORM FINE-BODY THRU EX-FINE-BODY.
      *
           MOVE 'E'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE PROG TO TFE-PROG.
           REWRITE RF-TFE INVALID 
                PERFORM INVK-TFE
                GO TO ERRIO.
      *
           ADD 1 TO NFAT.
       NOEXP.
           MOVE KFT-NUM TO ULFAT.
           GO TO NEWFAT.
       ENDFAT.
      **** rel 7.2
           MOVE IF-AZI      TO PFPER-AZI.
           MOVE IF-ATT      TO PFPER-CATT.
           MOVE ZERO        TO PFPER-KEYFT.
           MOVE ZERO        TO PFPER-KEYCR.
           MOVE 99          TO PFPER-TIPO.
           MOVE SPACE       TO PFPER-NFILE.
           MOVE ZERO        TO PFPER-CONT.
           MOVE ZERO        TO PFPER-SCRIVI.
           MOVE ZERO        TO PFPER-SAVALIVA.
           MOVE SPACE       TO PFPER-SAVNATURA.
           CALL 'vrcfper' USING PARFPER PARWXML.
      ************
           IF NFAT = ZERO
              MOVE 'Non  stato generato nessun file XML' TO F-MES1
              MOVE 1 TO F-NMES
              CALL 'vrmbox' USING PARMB
              GO TO EX-RUN-ELABORA.
           STRING 'Sono stati generati ' NFATA ' file XML.' 
                   DELIMITED SIZE INTO F-MES1.
           STRING 'Ultima fattura elaborata: ' ULFATA '.'
                   DELIMITED SIZE INTO F-MES2.
           MOVE 2 TO F-NMES.
           CALL 'vrmbox' USING PARMB.
           MOVE TFE-PROG TO IF-PROG.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       ESPORTA-HEADER.
           MOVE ZERO TO PARWXML.
           MOVE SPACE TO PWXM-NOMEFX.
           MOVE KFT-NUM TO NUMFAT.
           IF TFE-DIVIDI = ZERO
              STRING TFE-PERC DELIMITED SPACE
                     TFE-CNAZ DELIMITED SPACE
                     COMCFISC DELIMITED SPACE
                     '_' DELIMITED SIZE
                     PROG DELIMITED SIZE
                     '.xml' DELIMITED SIZE INTO PWXM-NOMEFX
           ELSE
              PERFORM VERIFICA-CARTELLA THRU EX-VERIFICA-CARTELLA
              STRING CARTELLA DELIMITED SPACE
                     TFE-CNAZ DELIMITED SPACE
                     COMCFISC DELIMITED SPACE
                     '_' DELIMITED SIZE
                     PROG DELIMITED SIZE
                     '.xml' DELIMITED SIZE INTO PWXM-NOMEFX
           MOVE SPACE TO PWXM-FUN.
           MOVE SPACE TO PWXM-TAG.
           MOVE SPACE TO PWXM-ATTR.
           MOVE ZERO  TO PWXM-TIPO.
           MOVE SPACE TO PWXM-CAMPO.
           MOVE ZERO  TO PWXM-NUM.
           MOVE ZERO  TO PWXM-DATA.
           MOVE 'U'   TO PWXM-ENCODE.
      * Inizio XML
           MOVE '+'  TO PWXM-FUN.
           MOVE 'p:FatturaElettronica' TO PWXM-TAG.
      *
      **** rel 7.2
      *    MOVE 'xmlns:ds' TO PWXM-NATTR(1).
           MOVE 'xsi:schemaLocation' TO PWXM-NATTR(1).
      *    MOVE 'http://www.w3.org/2000/09/xmldsig#' TO PWXM-VATTR(1).
      *    STRING 'http://ivaservizi.agenziaentrate.gov.it/'
      *           'docs/xsd/fatture/v1.2 fatturaordinaria_v1.2.xsd'
           STRING 'http://ivaservizi.agenziaentrate.gov.it/docs/xsd/'
                 'fatture/v1.2 http://www.fatturapa.gov.it/export/'
                 'fatturazione/sdi/fatturapa/v1.2/Schema_del_file_'
                 'xml_FatturaPA_versione_1.2.xsd'
                                        DELIMITED SIZE 
                                   INTO PWXM-VATTR(1).
      ************
      *
      **** rel 7.2
      *    MOVE 'xmlns:p' TO PWXM-NATTR(2).
           MOVE 'xmlns:xsi' TO PWXM-NATTR(2).
      *    MOVE 'http://www.fatturapa.gov.it/sdi/fatturapa/v1.1'
           MOVE 'http://www.w3.org/2001/XMLSchema-instance'
      ************
                  TO PWXM-VATTR(2).
      *
      **** rel 7.2
      *    MOVE 'xmlns:xsi' TO PWXM-NATTR(3).
           MOVE 'xmlns:p' TO PWXM-NATTR(3).
      *    MOVE 'http://www.w3.org/2001/XMLSchema-instance' 
      *           TO PWXM-VATTR(3).
           STRING 'http://ivaservizi.agenziaentrate.gov.it/docs/'
                  'xsd/fatture/v1.2' DELIMITED SIZE
                                 INTO PWXM-VATTR(3).
      ************
      *

      **** rel 7.2
           MOVE 'xmlns:ds' TO PWXM-NATTR(4).
           MOVE 'http://www.w3.org/2000/09/xmldsig#' 
                           TO PWXM-VATTR(4).
      *
      *    MOVE 'versione' TO PWXM-NATTR(4).
           MOVE 'versione' TO PWXM-NATTR(5).
      *    MOVE '1.1' TO PWXM-VATTR(4).
      **** rel 7.2
      *    MOVE 'FPA12' TO PWXM-VATTR(5).
           IF AFT-IPA NOT = SPACE
              MOVE TFE-FORM TO PWXM-VATTR(5)
           ELSE
              MOVE TFE-FORMB2B TO PWXM-VATTR(5).
      ************
           call 'vxml-wr-2-72' using parwxml.
      * Inizio Header
           MOVE '+'  TO PWXM-FUN.
           MOVE 'FatturaElettronicaHeader' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio Dati Trasmissione
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiTrasmissione' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE '+'  TO PWXM-FUN.
           MOVE 'IdTrasmittente' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'IdPaese' TO PWXM-TAG.
           MOVE TFE-NAZ TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'IdCodice' TO PWXM-TAG.
           MOVE TFE-CFISC TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'ProgressivoInvio' TO PWXM-TAG.
           MOVE PROG    TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'FormatoTrasmissione' TO PWXM-TAG.
      **** rel 7.2
      *    MOVE TFE-FORM  TO PWXM-CAMPO.
           IF AFT-IPA NOT = SPACE
              MOVE TFE-FORM TO PWXM-CAMPO
           ELSE
              MOVE TFE-FORMB2B TO PWXM-CAMPO.
      ************
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'CodiceDestinatario' TO PWXM-TAG.
      **** rel 7.2
      *    MOVE AFT-IPA   TO PWXM-CAMPO.
           IF AFT-IPA NOT = SPACE
              MOVE AFT-IPA TO PWXM-CAMPO
           ELSE
              IF AFT-DEST = SPACE 
                 IF ESTEROSINO = ZERO 
                    MOVE '0000000' TO PWXM-CAMPO
                 ELSE
                    MOVE 'XXXXXXX' TO PWXM-CAMPO
                 END-IF
              ELSE
                 MOVE AFT-DEST TO PWXM-CAMPO.
      ************
           call 'vxml-wr-2-72' using parwxml.
           IF CLF-13IVA NOT = 2
              IF ESTEROSINO = ZERO AND
                 AFT-IPA = SPACE AND
                 AFT-DEST = SPACE
                 IF AFT-PEC = SPACE OR
                    AFT-PEC = ALL '0' OR
                    AFT-PEC = LOW-VALUE OR
                    AFT-PEC = HIGH-VALUE
                    MOVE KFT-NUM TO NUMFAT
                    STRING 'Attenzione. Sulla Fattura numero ' NUMFATA
                            DELIMITED SIZE INTO F-MES1
                    MOVE 'non  presente nessun codice IPA, ' 
                          TO F-MES2
                    MOVE 'codice destinatario o PEC. La fattura' 
                          TO F-MES3
                    MOVE 'verr esportata senza questi dati.'
                          TO F-MES4
                    MOVE 4 TO F-NMES
                    CALL 'vrmbox' USING PARMB.
      **** rel 7.2
      *
           IF AFT-IPA  = SPACE AND
              AFT-DEST = SPACE AND
              AFT-PEC NOT = SPACE AND
              AFT-PEC NOT = ALL '0' AND
              AFT-PEC NOT = LOW-VALUE AND
              AFT-PEC NOT = HIGH-VALUE
              MOVE 'PECDestinatario' TO PWXM-TAG
              MOVE AFT-PEC TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      ************
      * Fine Dati Trasmissione
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio Cedente Prestatore
           MOVE '+'  TO PWXM-FUN.
           MOVE 'CedentePrestatore' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio Dati Anagrafici
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiAnagrafici' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF AZI-PIVA NOT = ZERO
              MOVE '+'  TO PWXM-FUN
              MOVE 'IdFiscaleIVA' TO PWXM-TAG
              call 'vxml-wr-2-72' using parwxml
      *
              MOVE 'IdPaese' TO PWXM-TAG
              IF TFE-CNAZ = SPACE
                 MOVE 'IT'  TO PWXM-CAMPO
              ELSE
                 MOVE TFE-CNAZ TO PWXM-CAMPO
              END-IF
              call 'vxml-wr-2-72' using parwxml
      *
              MOVE 'IdCodice' TO PWXM-TAG
              MOVE AZI-PIVA  TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml
      *
              MOVE '-'  TO PWXM-FUN
              call 'vxml-wr-2-72' using parwxml
           ELSE
              MOVE 'CodiceFiscale' TO PWXM-TAG
              MOVE AZI-CFISC TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Anagrafica' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF AAZ-NOM = SPACE
              MOVE 'Denominazione' TO PWXM-TAG
              MOVE AZI-RGSOC       TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml
           ELSE
              MOVE 'Nome'  TO PWXM-TAG
              MOVE AAZ-NOM TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml
      *
              MOVE 'Cognome' TO PWXM-TAG
              MOVE AAZ-CGN   TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'RegimeFiscale' TO PWXM-TAG.
           MOVE TFE-REGF        TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      * Fine Dati Anagrafici
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio Sede
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Sede' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Indirizzo' TO PWXM-TAG.
           MOVE AZI-INDIR   TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'CAP' TO PWXM-TAG.
           MOVE AZI-CAP  TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Comune' TO PWXM-TAG.
           MOVE AZI-CIT  TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF AZI-PRV NOT = SPACE
              MOVE 'Provincia' TO PWXM-TAG
              MOVE AZI-PRV  TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Nazione' TO PWXM-TAG.
           MOVE TFE-CNAZ  TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      * Fine Sede
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
           MOVE 02        TO J02-TIP.
           MOVE KAZ-COD   TO J02-COD.
           MOVE 'D'       TO J02-PRG.
           MOVE J02-KEYID TO KEYSST.
           READ SPETAB INTO REKJ02 INVALID PERFORM INVK-SST
                                   GO TO ERRIO.
      *
           IF J02-STAB-XIND = SPACE AND
              J02-STAB-CAP  = ZERO  AND
              J02-STAB-CIT  = SPACE AND
              J02-STAB-PRV  = SPACE AND
              J02-STAB-NAZ  = SPACE
              GO TO NOSTABILE1.
      * Inizio StabileOrganizzazione
           MOVE '+'  TO PWXM-FUN.
           MOVE 'StabileOrganizzazione' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Indirizzo' TO PWXM-TAG.
           MOVE J02-STAB-XIND TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'CAP' TO PWXM-TAG.
           MOVE J02-STAB-CAP TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'Comune' TO PWXM-TAG.
           MOVE J02-STAB-CIT TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           IF J02-STAB-PRV NOT = SPACE
              MOVE 'Provincia' TO PWXM-TAG
              MOVE J02-STAB-PRV TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'Nazione' TO PWXM-TAG.
           MOVE J02-STAB-NAZ TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      * Fine StabileOrganizzazione
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
       NOSTABILE1.
      *
      * Inizio IscrizioneREA
      **** rel 7.1
           IF TFE-NREA = SPACE OR
              TFE-UFFICIO = SPACE
              GO TO NOREA.
      ************
           MOVE '+'  TO PWXM-FUN.
           MOVE 'IscrizioneREA' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Ufficio' TO PWXM-TAG.
           MOVE TFE-UFFICIO TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'NumeroREA' TO PWXM-TAG.
           MOVE TFE-NREA  TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
      **** rel 7.1
      *    MOVE 'CapitaleSociale' TO PWXM-TAG.
      *    MOVE TFE-CAPSOC TO COMNUM.
      *    PERFORM T-CIFRA THRU EX-T-CIFRA.
      *    STRING COMNUM(K1:10 - K1 + 1) '.00' 
      *           DELIMITED SIZE INTO PWXM-CAMPO.
      *    call 'vxml-wr-2-72' using parwxml.
           IF TFE-CAPSOC NOT = ZERO
              MOVE 'CapitaleSociale' TO PWXM-TAG
              MOVE TFE-CAPSOC TO COMNUM
              PERFORM T-CIFRA THRU EX-T-CIFRA
              STRING COMNUM(K1:10 - K1 + 1) '.00' 
                     DELIMITED SIZE INTO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'SocioUnico' TO PWXM-TAG.
           MOVE TFE-SOCUNI TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'StatoLiquidazione' TO PWXM-TAG.
           MOVE TFE-STALIQ TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      * Fine IscrizioneREA
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      **** rel 7.1
       NOREA.
      ************
      * Fine Cedente Prestatore
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF J02-CFRAP  = SPACE AND
              J02-CORAP  = SPACE AND
              J02-NORAP  = SPACE AND
              J02-NAZRAP = SPACE AND
              J02-DENOM  = SPACE
              GO TO NORAPR1.
      * Inizio RappresentanteFiscale
           MOVE '+'  TO PWXM-FUN.
           MOVE 'RappresentanteFiscale' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio DatiAnagrafici
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiAnagrafici' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF J02-DENOM = SPACE
              GO TO RAP-FISICO.
      * Inizio IdFiscaleIVA
           MOVE '+'  TO PWXM-FUN.
           MOVE 'IdFiscaleIVA' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'IdPaese' TO PWXM-TAG.
           MOVE J02-NAZRAP   TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'IdCodice' TO PWXM-TAG.
           MOVE J02-CFRAP   TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      * Fine IdFiscaleIVA
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           GO TO FINE-FISC.
       RAP-FISICO.
           MOVE 'CodiceFiscale' TO PWXM-TAG.
           MOVE J02-CFRAP   TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
       FINE-FISC.
      * Inizio Anagrafica
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Anagrafica' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF J02-CORAP = SPACE
              MOVE 'Denominazione' TO PWXM-TAG
              MOVE J02-DENOM   TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml 
           ELSE
              MOVE 'Nome' TO PWXM-TAG
              MOVE J02-NORAP   TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml 
      *
              MOVE 'Cognome' TO PWXM-TAG
              MOVE J02-CORAP   TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml. 
      * Fine Anagrafica
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      * Fine DatiAnagrafici
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      * Fine RappresentanteFiscale
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       NORAPR1.
      * Inizio CessionarioCommittente
           MOVE '+'  TO PWXM-FUN.
           MOVE 'CessionarioCommittente' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio Dati Anagrafici
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiAnagrafici' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF PDSPS-PIVA NOT = SPACE
              MOVE '+'  TO PWXM-FUN
              MOVE 'IdFiscaleIVA' TO PWXM-TAG
              call 'vxml-wr-2-72' using parwxml
      *
              MOVE 'IdPaese' TO PWXM-TAG
              MOVE PDSPS-NAZ TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml
      *
              MOVE 'IdCodice' TO PWXM-TAG
              MOVE PDSPS-PIVA  TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml
      *
              MOVE '-'  TO PWXM-FUN
              call 'vxml-wr-2-72' using parwxml
           ELSE
              MOVE 'CodiceFiscale' TO PWXM-TAG
              MOVE PDSPS-CFISC TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Anagrafica' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF SPS-COGNOME = SPACE
              MOVE 'Denominazione' TO PWXM-TAG
              IF CLF-RGSOC2 NOT = SPACE
                 MOVE CLF-XRGS        TO PWXM-CAMPO
              ELSE
                 MOVE CLF-RGSOC      TO PWXM-CAMPO
              END-IF
              call 'vxml-wr-2-72' using parwxml
           ELSE
              MOVE 'Nome'   TO PWXM-TAG
              MOVE SPS-NOME TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml
      *
              MOVE 'Cognome'   TO PWXM-TAG
              MOVE SPS-COGNOME TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
      * Fine Dati Anagrafici
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio Sede
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Sede' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Indirizzo' TO PWXM-TAG.
           IF CLF-INDIR2 NOT = SPACE
              MOVE CLF-XIND        TO PWXM-CAMPO
           ELSE
              MOVE CLF-INDIR      TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'CAP' TO PWXM-TAG.
           MOVE CLF-CAP  TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Comune' TO PWXM-TAG.
           MOVE CLF-CIT  TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF CLF-PRV NOT = SPACE
              MOVE 'Provincia' TO PWXM-TAG
              MOVE CLF-PRV  TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Nazione' TO PWXM-TAG.
           MOVE PDSPS-NAZ TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      * Fine Sede
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      **** rel 7.2
           IF AFT-IPA NOT = SPACE
              GO TO NODATI.
           IF SPS-STAB-XIND = SPACE AND
              SPS-STAB-CAP  = ZERO  AND
              SPS-STAB-CIT  = SPACE AND
              SPS-STAB-PRV  = SPACE AND
              SPS-STAB-NAZ  = SPACE
              GO TO NOSTABILE.
      * Inizio StabileOrganizzazione
           MOVE '+'  TO PWXM-FUN.
           MOVE 'StabileOrganizzazione' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Indirizzo' TO PWXM-TAG.
           IF SPS-STAB-INDIR2 NOT = SPACE
              MOVE SPS-STAB-XIND TO PWXM-CAMPO
           ELSE
              MOVE SPS-STAB-INDIR TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'CAP' TO PWXM-TAG.
           MOVE SPS-STAB-CAP  TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Comune' TO PWXM-TAG.
           MOVE SPS-STAB-CIT  TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF SPS-STAB-PRV NOT = SPACE
              MOVE 'Provincia' TO PWXM-TAG
              MOVE SPS-STAB-PRV  TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Nazione' TO PWXM-TAG.
           IF SPS-STAB-NAZ = SPACE
              MOVE 'IT'  TO PWXM-CAMPO
           ELSE
              MOVE SPS-STAB-NAZ TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      * Fine StabileOrganizzazione
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
       NOSTABILE.
      *
           IF SPS-RAPR-PAESE = SPACE   AND
              SPS-RAPR-NOME  = SPACE   AND
              SPS-RAPR-IDFISC  = SPACE AND
              SPS-RAPR-DENOM  = SPACE  AND
              SPS-RAPR-COGNOME  = SPACE
              GO TO NODATI.
      * Inizio RappresentanteFiscale
           MOVE '+'  TO PWXM-FUN.
           MOVE 'RappresentanteFiscale' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio IdFiscaleIVA
           MOVE '+'  TO PWXM-FUN.
           MOVE 'IdFiscaleIVA' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'IdPaese' TO PWXM-TAG.
           MOVE SPS-RAPR-PAESE   TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'IdCodice' TO PWXM-TAG.
           MOVE SPS-RAPR-IDFISC   TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      * Fine IdFiscaleIVA
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF SPS-RAPR-COGNOME = SPACE
              MOVE 'Denominazione' TO PWXM-TAG
              MOVE SPS-RAPR-DENOM   TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml 
           ELSE
              MOVE 'Nome' TO PWXM-TAG
              MOVE SPS-RAPR-NOME   TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml 
      *
              MOVE 'Cognome' TO PWXM-TAG
              MOVE SPS-RAPR-COGNOME   TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml. 
      * Fine RappresentanteFiscale
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       NODATI.
      ************
      * Fine CessionarioCommittente
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      * Fine Header
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       EX-ESPORTA-HEADER.
           EXIT.
      *------------------
       INIZIO-BODY.
      * Inizio Body
           MOVE '+'  TO PWXM-FUN.
           MOVE 'FatturaElettronicaBody' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio DatiGenerali
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiGenerali' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio DatiGeneraliDocumento
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiGeneraliDocumento' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'TipoDocumento' TO PWXM-TAG.
      **** rel 7.2
      *    IF KFT-TDOC = 1 OR 2 OR 4
      *       IF AFT-TIPO = ZERO
      *          MOVE 'TD01' TO PWXM-CAMPO
      *       END-IF
      *       IF AFT-TIPO = 1
      *          MOVE 'TD05' TO PWXM-CAMPO
      *       END-IF
      *       IF AFT-TIPO = 2
      *          MOVE 'TD02' TO PWXM-CAMPO.
      *    IF KFT-TDOC = 3 OR 6
      *       MOVE 'TD04' TO PWXM-CAMPO.
           MOVE AFT-TIPOD TO PWXM-CAMPO.
           IF AFT-TIPOD = SPACE OR
              AFT-TIPOD = '0000' OR
              AFT-TIPOD = LOW-VALUE
              IF KFT-TDOC NOT = 3 AND
                 KFT-TDOC NOT = 6
                 IF AFT-TIPO = ZERO
                    MOVE 'TD01' TO PWXM-CAMPO
                 ELSE
                    IF AFT-TIPO = 1
                       MOVE 'TD05' TO PWXM-CAMPO
                    ELSE
                       MOVE 'TD02' TO PWXM-CAMPO
                    END-IF
                 END-IF
              ELSE
                 MOVE 'TD04' TO PWXM-CAMPO.
      ************
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 10        TO KTB-TIP.
           MOVE FAT-VALUT TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE 'EUR' TO T10-DSINT.
           MOVE 'Divisa' TO PWXM-TAG.
           MOVE T10-DSINT TO PWXM-CAMPO COMVALUT.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Data' TO PWXM-TAG.
           MOVE 2 TO TIPOP1.
           MOVE FAT-DATA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           STRING AA4 '-' MM4 '-' GG4 DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE KFT-NUM TO NUMFAT.
           MOVE 'Numero' TO PWXM-TAG.
           STRING       KFT-AZI
                        IF-ATT
                        KFT-TDOC
                        AA9
                        NUMFAT
           DELIMITED SPACE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
      **** rel 7.2
           IF (BCT-PBASE = ZERO) AND (BCT-PRACC = ZERO) GO TO NORITE.
           MOVE ZERO TO IMPRIT.
           MOVE 1 TO K2.
           PERFORM UNTIL K2 > 6
                ADD FAT-IMPON(K2) TO IMPRIT
                ADD 1 TO K2.
      *
           COMPUTE IMPO = (IMPRIT / 100) * BCT-PBASE.
           COMPUTE PERRIT = (BCT-PRACC / 100) * BCT-PBASE.
           MOVE IMPO      TO ER-IMPORTO.
           MOVE ZERO      TO ER-VALUT.
           MOVE BCT-PRACC TO COM-ALIVA.
           CALL 're2iva' USING ER-IMPORTO ER-VALUT COM-ALIVA
           MOVE ER-IMPORTO TO RITE.
      * Inizio DatiRitenuta
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiRitenuta' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'TipoRitenuta' TO PWXM-TAG.
           IF TFE-TIPORIT = ZERO
              MOVE 'RT01'  TO PWXM-CAMPO
           ELSE
              MOVE 'RT02'  TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'ImportoRitenuta' TO PWXM-TAG.
           MOVE RITE TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'AliquotaRitenuta' TO PWXM-TAG.
           MOVE PERRIT TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'CausalePagamento' TO PWXM-TAG
           MOVE TFE-CAUS TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
      * Fine DatiRitenuta
           MOVE '-'  TO PWXM-FUN
           call 'vxml-wr-2-72' using parwxml.
       NORITE.
      *
           MOVE 03        TO KSPI-TIP.
           MOVE FAT-CDESE TO KSPI-COD.
           READ SPEIVA INVALID
                MOVE ZERO TO SPI-ADDBOL.
      *
           MOVE 3 TO KTB-TIP.
           MOVE FAT-CDESE TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
               MOVE ZERO TO T03-TPIVA.
           MOVE T03-TPIVA TO ESTPIVA.
      *
           IF SPI-ADDBOL = 1   
              IF FAT-TOTFT > IMPSC
      * Inizio DatiBollo
                 MOVE '+'  TO PWXM-FUN
                 MOVE 'DatiBollo' TO PWXM-TAG
                 call 'vxml-wr-2-72' using parwxml
      *
                 MOVE 'BolloVirtuale' TO PWXM-TAG
                 MOVE 'SI'  TO PWXM-CAMPO
                 call 'vxml-wr-2-72' using parwxml
      *
                 MOVE 'ImportoBollo' TO PWXM-TAG
                 MOVE IMBOL TO COMNUM
                 PERFORM T-CIFRA THRU EX-T-CIFRA
                 STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                        DELIMITED SIZE INTO PWXM-CAMPO
                 call 'vxml-wr-2-72' using parwxml
      * Fine DatiBollo
                 MOVE '-'  TO PWXM-FUN
                 call 'vxml-wr-2-72' using parwxml.
      * ImportoTotaleDocumento
           MOVE 'ImportoTotaleDocumento' TO PWXM-TAG.
           IF FAT-VALUT = ZERO OR COMEURO
              MOVE FAT-TOTFT TO COMNUM
           ELSE
              MOVE FAT-TOVAL TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
      ************
      * Fine DatiGeneraliDocumento
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF FLGORD = ZERO
              IF AFT-FAORD = SPACE
                 GO TO NOORD.
      * Inizio DatiOrdineAcquisto
      *    MOVE '+'  TO PWXM-FUN.
      *    MOVE 'DatiOrdineAcquisto' TO PWXM-TAG.
      *    call 'vxml-wr-2-72' using parwxml.
      *
           IF AFT-FAORD = SPACE
              PERFORM LISTA-ORDINI THRU EX-LISTA-ORDINI
           ELSE
      * Inizio DatiOrdineAcquisto
              MOVE '+'  TO PWXM-FUN
              MOVE 'DatiOrdineAcquisto' TO PWXM-TAG
              call 'vxml-wr-2-72' using parwxml
      *
              MOVE 'IdDocumento' TO PWXM-TAG
              MOVE AFT-FAORD TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml
      *
              IF AFT-FADTORD NOT = ZERO
                 MOVE 'Data' TO PWXM-TAG
                 MOVE 2 TO TIPOP1
                 MOVE AFT-FADTORD TO AAGGG
                 CALL 'rdata' USING PARCDT
                 STRING AA4 '-' MM4 '-' GG4 DELIMITED SIZE 
                        INTO PWXM-CAMPO
                 call 'vxml-wr-2-72' using parwxml
              END-IF
      *
              IF AFT-CUP NOT = SPACE
                 MOVE 'CodiceCUP' TO PWXM-TAG
                 MOVE AFT-CUP TO PWXM-CAMPO
                 call 'vxml-wr-2-72' using parwxml
              END-IF
      *
              IF AFT-CIG NOT = SPACE
                 MOVE 'CodiceCIG' TO PWXM-TAG
                 MOVE AFT-CIG TO PWXM-CAMPO
                 call 'vxml-wr-2-72' using parwxml
              END-IF
      * Fine DatiOrdineAcquisto
              MOVE '-'  TO PWXM-FUN
              call 'vxml-wr-2-72' using parwxml.
       NOORD.
           MOVE ZERO TO K.
       LOOPRB.
           ADD 1 TO K.
           IF RB-TNUM(K) = ZERO OR
              RB-NBOL(K) = ZERO
              GO TO NODDT.
           MOVE KFT-AZI    TO KBC-AZI.
           MOVE RB-TNUM(K) TO KBC-NUM.
           MOVE RB-NBOL(K) TO KBC-BOL.
           READ BOLCTE INVALID GO TO NODDT.
      **** rel 7.2
      *    IF KBC-NUM = 7 OR 8 OR 9 GO TO NODDT.
           IF KBC-NUM = 6 OR 7 OR 8 OR 9 GO TO NODDT.
      ************
      *    
      * Inizio DatiDDT
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiDDT' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'NumeroDDT' TO PWXM-TAG.
           STRING KBC-NUM '/' KBC-BOL DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'DataDDT' TO PWXM-TAG.
           MOVE 2 TO TIPOP1.
           MOVE BCT-DATA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           STRING AA4 '-' MM4 '-' GG4 DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF FLGBCT = ZERO
              GO TO ENDLAV2.
           MOVE ZERO TO KEYLV.
           MOVE KBC-AZI TO KLV-AZI.
           MOVE KBC-NUM TO KLV-NBOL.
           MOVE KBC-BOL TO KLV-NUBOL.
           MOVE ZERO    TO KLV-PRGN.
           START WDSLAV KEY NOT < SKEYLV1 INVALID GO TO ENDLAV2.
       NEWLAV2.
           READ WDSLAV NEXT AT END GO TO ENDLAV2.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO NEWLAV2.
           IF KLV-AZI   > KBC-AZI GO TO ENDLAV2.
           IF KLV-NBOL  > KBC-NUM GO TO ENDLAV2.
           IF KLV-NUBOL > KBC-BOL GO TO ENDLAV2.
      *
           MOVE 'RiferimentoNumeroLinea' TO PWXM-TAG.
           MOVE KLV-PRGN TO COM-PRG.
           MOVE COM-PRG TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           GO TO NEWLAV2.
       ENDLAV2.
      *
      * Fine DatiDDT
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           GO TO LOOPRB.
       NODDT.
      * Fine DatiGenerali
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio DatiBeniServizi
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiBeniServizi' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
       EX-INIZIO-BODY.
           EXIT.
      *------------------
       ESPORTA-DATI-BODY.
      **** rel 7.2
           MOVE ZERO TO SPESAC.
      ************
      * Inizio DettaglioLinee
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DettaglioLinee' TO PWXM-TAG.
           MOVE SPACE TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'NumeroLinea' TO PWXM-TAG.
           MOVE CONT TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF BCR-TCOR = ZERO OR 1 OR 2 GO TO NOCES.
      *
           MOVE 11           TO KTB-TIP.
           MOVE BCR-SPESA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
      **** rel 7.2
                    MOVE ZERO TO T11-SCONT
      ************
                    MOVE 1 TO T11-TACC.
      **** rel 7.2
           MOVE KEYTB TO KEYB2S.
           READ B2BSPE INVALID MOVE ZERO TO B2S-TIPO.
           IF B2S-TIPO = ZERO
              GO TO NOCES.
      ************
      *
           MOVE 'TipoCessionePrestazione' TO PWXM-TAG.
           IF BCR-TCOR = 3
      **** rel 7.2
      *       IF T11-TACC = 1
      *          MOVE 'AC' TO PWXM-CAMPO
      *       ELSE
      *          MOVE 'SC' TO PWXM-CAMPO.
              IF B2S-TIPO = 1
                 MOVE 'SC' TO PWXM-CAMPO
              END-IF
              IF B2S-TIPO = 2
                 MOVE 'PR' TO PWXM-CAMPO
              END-IF
              IF B2S-TIPO = 3
                 MOVE 'AB' TO PWXM-CAMPO
              END-IF
              IF B2S-TIPO = 4
      **** rel 7.2
                 MOVE 1 TO SPESAC
      ************
                 MOVE 'AC' TO PWXM-CAMPO.
      ************
           IF BCR-TCOR = 4
              MOVE 'AB' TO PWXM-CAMPO.
           IF BCR-TCOR = 5
      *       MOVE 'SC' TO PWXM-CAMPO.
              MOVE 'AB' TO PWXM-CAMPO.
           IF BCR-TCOR = 6
              GO TO NOCES.
      *       MOVE 'AB' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
       NOCES.
      **** rel 7.2
           IF BCR-TCOR = 1 GO TO NO-CODART.
           MOVE TFE-EXPART TO B2A-ESPORTA.
           IF BCR-ART NOT = SPACE
              MOVE KCR-AZI TO KB2A-AZI
              MOVE BCR-ART TO KB2A-ART
              READ B2BART INVALID 
                   MOVE SPACE   TO B2A-TIPO
                   MOVE SPACE   TO B2A-CODICE
                   MOVE TFE-EXPART TO B2A-ESPORTA
              END-READ
           ELSE
              GO TO NO-CODART.
           IF B2A-ESPORTA = ZERO GO TO NO-CODART.
      *    IF B2A-TIPO = SPACE AND
      *       TFE-TIPOART = SPACE
      *       GO TO NO-CODART.
      * Inizio CodiceArticolo
           MOVE '+'  TO PWXM-FUN.
           MOVE 'CodiceArticolo' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'CodiceTipo' TO PWXM-TAG.
           IF B2A-TIPO NOT = SPACE
              MOVE B2A-TIPO    TO PWXM-CAMPO
           ELSE
              IF TFE-TIPOART NOT = SPACE 
                 MOVE TFE-TIPOART TO PWXM-CAMPO
              ELSE
                 MOVE 'CODFOR' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'CodiceValore' TO PWXM-TAG.
           IF B2A-CODICE NOT = SPACE
              MOVE B2A-CODICE TO PWXM-CAMPO
           ELSE
              MOVE BCR-ART    TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      * Fine CodiceArticolo
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      * 
       NO-CODART.
           MOVE SPACE TO PCFA-DISE PCFA-CBAR PCFA-ARTE.
           IF BCR-ART = SPACE
              GO TO NO-CODEST.
           MOVE KBC-AZI TO PCFA-AZI.
           MOVE ZERO    TO PCFA-FUN.
           MOVE 'C'     TO PCFA-TIP.
           MOVE BCT-CLI TO PCFA-CLF.
           MOVE BCR-ART TO PCFA-ART.
           MOVE CLF-FLING TO PCFA-LIN.
           CALL 'vrrcfa' USING PARPCFA
           IF PCFA-ST NOT = ZERO
              GO TO NO-CODEST.
      *
           IF PCFA-ARTE = SPACE
              GO TO NO-CODEST.
           IF SCESC = ZERO
              GO TO NO-CODEST.
      *
      * Inizio CodiceArticolo
           MOVE '+'  TO PWXM-FUN.
           MOVE 'CodiceArticolo' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'CodiceTipo' TO PWXM-TAG.
           MOVE 'CODCLI'    TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'CodiceValore' TO PWXM-TAG.
           MOVE PCFA-ARTE    TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      * Fine CodiceArticolo
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      * 
       NO-CODEST.
           IF PCFA-DISE = SPACE
              GO TO NO-DISE.
           IF SDISC = ZERO
              GO TO NO-DISE.
      *
      * Inizio CodiceArticolo
           MOVE '+'  TO PWXM-FUN.
           MOVE 'CodiceArticolo' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'CodiceTipo' TO PWXM-TAG.
           MOVE 'DISEGNO'    TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'CodiceValore' TO PWXM-TAG.
           MOVE PCFA-DISE    TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      * Fine CodiceArticolo
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      * 
       NO-DISE.
      *
           MOVE KEYCR TO KEYNCR.
           MOVE BCR-DESCR TO PWXM-CAMPO COM-DESC.
           IF BCR-TCOR = 1
              MOVE SPACE TO PWXM-CAMPO COM-DESC. 
           MOVE ZERO TO KNCR-PGRN.
           START NOTBCR KEY NOT < KEYNCR INVALID GO TO NOCES10.
       RDN-NCR.
           MOVE PWXM-CAMPO TO COM-DESC.
           READ NOTBCR NEXT AT END GO TO NOCES10.
           IF KNCR-AZI NOT = KCR-AZI GO TO NOCES10.
           IF KNCR-NUM NOT = KCR-NUM GO TO NOCES10.
           IF KNCR-BOL NOT = KCR-BOL GO TO NOCES10.
           IF KNCR-PGR NOT = KCR-PGR GO TO NOCES10.
           PERFORM CERCA-ULTIMO THRU EX-CERCA-ULTIMO.
           STRING COM-DESC(1:KU2) ' '
                  NCR-DESCR DELIMITED BY SIZE 
                  INTO PWXM-CAMPO.
           GO TO RDN-NCR.
       NOCES10.
           MOVE COM-DESC TO PWXM-CAMPO.
           MOVE 'Descrizione' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
      **** rel 7.2
           IF BCR-TCOR = 3 AND B2S-TIPO = ZERO
              GO TO SI-QTA.
      **********
           IF BCR-QTA = ZERO GO TO NOCES20.
      **** rel 7.2
       SI-QTA.
      **********
           MOVE 'Quantita' TO PWXM-TAG.
           MOVE BCR-QTA TO COMNUM.
      **** rel 7.2
           IF BCR-TCOR = 3
              IF B2S-TIPO = ZERO
                 MOVE 1 TO COMNUM.
      **********
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:3)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'UnitaMisura' TO PWXM-TAG.
           MOVE BCR-UM TO PWXM-CAMPO.
      **** rel 7.2
           IF BCR-TCOR = 3
              IF B2S-TIPO = ZERO
                 MOVE 'NR' TO PWXM-CAMPO.
      **********
           call 'vxml-wr-2-72' using parwxml.
       NOCES20.
      ************
           MOVE 'PrezzoUnitario' TO PWXM-TAG.
           MOVE BCR-PZLOR TO COMNUM.
           IF BCR-TCOR = 6
              MOVE ZERO TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
      **** rel 7.2
      *    STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
           IF BCR-TCOR = 3 AND T11-TACC NOT = 1
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO
           ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
      *************
                  DELIMITED SIZE INTO PWXM-CAMPO.
      **** rel 7.2
           IF BCR-QTA < ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO.
      **********
           call 'vxml-wr-2-72' using parwxml.
      *
      **** rel 7.2
           IF BCR-TCOR NOT = ZERO AND BCR-TCOR NOT = 2 GO TO NOSCONTO.
           IF BCR-FPNET = 1 GO TO NOSCONTO.

           IF BCT-SCBAS NOT = ZERO
      * Inizio ScontoMaggiorazione Base
              MOVE '+'  TO PWXM-FUN
              MOVE 'ScontoMaggiorazione' TO PWXM-TAG
              call 'vxml-wr-2-72' using parwxml
              MOVE 'Tipo' TO PWXM-TAG
              MOVE 'SC' TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml
              MOVE 'Percentuale' TO PWXM-TAG
              MOVE BCT-SCBAS TO COMNUM
              PERFORM T-CIFRA THRU EX-T-CIFRA
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml      
      *
      * Fine ScontoMaggiorazione Base
              MOVE '-'  TO PWXM-FUN
              call 'vxml-wr-2-72' using parwxml.

           IF BCR-SC1 NOT = ZERO
      * Inizio ScontoMaggiorazione Sconto 1
              MOVE '+'  TO PWXM-FUN
              MOVE 'ScontoMaggiorazione' TO PWXM-TAG
              call 'vxml-wr-2-72' using parwxml
              MOVE 'Tipo' TO PWXM-TAG
              MOVE 'SC' TO PWXM-CAMPO
              IF BCR-SC1 < ZERO
                 MOVE 'MG' TO PWXM-CAMPO
              END-IF
              call 'vxml-wr-2-72' using parwxml
              MOVE 'Percentuale' TO PWXM-TAG
              MOVE BCR-SC1 TO COMNUM
              PERFORM T-CIFRA THRU EX-T-CIFRA
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml
      *
      * Fine ScontoMaggiorazione Sconto 1
              MOVE '-'  TO PWXM-FUN
              call 'vxml-wr-2-72' using parwxml.

           IF BCR-SC2 NOT = ZERO
      * Inizio ScontoMaggiorazione Sconto 2
              MOVE '+'  TO PWXM-FUN
              MOVE 'ScontoMaggiorazione' TO PWXM-TAG
              call 'vxml-wr-2-72' using parwxml
              MOVE 'Tipo' TO PWXM-TAG
              MOVE 'SC' TO PWXM-CAMPO
              IF BCR-SC2 < ZERO
                 MOVE 'MG' TO PWXM-CAMPO
              END-IF
              call 'vxml-wr-2-72' using parwxml
              MOVE 'Percentuale' TO PWXM-TAG
              MOVE BCR-SC2 TO COMNUM
              PERFORM T-CIFRA THRU EX-T-CIFRA
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml
      *
      * Fine ScontoMaggiorazione Sconto 2
              MOVE '-'  TO PWXM-FUN
              call 'vxml-wr-2-72' using parwxml.

       NOSCONTO.
      * Ricalcolo Prezzo Totale Versione Pa 1.2
           IF BCR-TCOR = 3 
              MOVE BCR-PZLOR TO CALCNUM
              GO TO NO-RICALCOLO-SCONTI.
           IF BCR-TCOR > 3 AND < 7
            MOVE BCR-PZLOR TO CALCNUM
           ELSE
      **** rel 7.2
           IF BCR-FPNET = 1 
            MOVE BCR-PZLOR TO CALCNUM
            ELSE
      ************
            COMPUTE CALCNUM = BCR-PZLOR - (BCR-PZLOR * BCT-SCBAS / 100).
           COMPUTE CALCNUM = CALCNUM - CALCNUM * BCR-SC1 / 100.
           COMPUTE CALCNUM = CALCNUM - CALCNUM * BCR-SC2 / 100.
           COMPUTE CALCNUM = CALCNUM * BCR-QTA.
       NO-RICALCOLO-SCONTI.
           MOVE CALCNUM TO RD-NUM.
           IF BCT-VALUT = 1 CALL 'vrround' USING NNN-X PARRD DEC-0
              ELSE          CALL 'vrround' USING NNN-X PARRD DEC-2.
      * 
           MOVE 'PrezzoTotale' TO PWXM-TAG.
      **** rel 7.2
           MOVE BCR-NETRG TO COMNUM.
      *    IF RD-NUM NOT = BCR-NETRG
      *       MOVE RD-NUM TO COMNUM
      *    ELSE
      *       MOVE BCR-NETRG TO COMNUM.
      *    IF BCR-TCOR = 5
      *       MOVE ZERO TO COMNUM.
           IF BCR-TCOR = 6
              MOVE ZERO TO COMNUM.
      ************
           PERFORM T-CIFRA THRU EX-T-CIFRA.
      **** rel 7.2
      *    STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
      *           DELIMITED SIZE INTO PWXM-CAMPO.
           IF BCR-TCOR = 3 AND T11-TACC NOT = 1
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO
           ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO.
      *************
      **** rel 7.2
           IF BCR-QTA < ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO.
      **********
           call 'vxml-wr-2-72' using parwxml.
      *
      **** rel 7.2
           MOVE COMNUM TO SAVPRZ SAVPRZ2.
           IF BCR-TCOR = 3 AND T11-SCONT = 1
              MOVE ZERO TO SAVPRZ.
           IF BCR-TCOR = 3 AND T11-TACC NOT = 1
              COMPUTE SAVPRZ = SAVPRZ * ( -1 ).
      ************
           MOVE 'AliquotaIVA' TO PWXM-TAG.
           IF FAT-CDESE = ZERO
              IF BCR-TCOR = 4 OR 5
                 MOVE BCR-RIVGR TO BCR-IVA COMCDIVA
              END-IF
              MOVE BCR-IVA TO KTB-COD COMCDIVA
           ELSE
              MOVE FAT-CDESE TO KTB-COD COMCDIVA.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE ZERO TO T03-ALIVA.
      **** rel 7.2
           PERFORM RCDIVA THRU EX-RCDIVA.
      ************
      **** rel 7.2
      *    MOVE T03-ALIVA TO COMNUM.
           MOVE T03-ALIVA TO COMNUM.
           IF BCR-TCOR = 1 AND SAVALIVA NOT = ZERO
              MOVE SAVALIVA TO COMNUM T03-ALIVA.
      ************
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF BCR-TCOR = 1 AND SAVNATURA NOT = SPACE
              MOVE SAVNATURA TO PWXM-CAMPO
              MOVE 'Natura' TO PWXM-TAG
              call 'vxml-wr-2-72' using parwxml
           ELSE
              PERFORM NATURA THRU EX-NATURA.
      *
      **** rel 7.2
           IF SPESAC = 1
              PERFORM SPESEAC THRU EX-SPESEAC.
      ************
           IF BCR-TCOR = 5 OR 4 OR 6
              PERFORM DETTAGLI-OMA  THRU EX-DETTAGLI-OMA.
           PERFORM LETTERA-DINT THRU EX-LETTERA-DINT.
      * Fine DettaglioLinee
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       EX-ESPORTA-DATI-BODY.
           EXIT.
      *------------------
       FINE-BODY.
      **** rel 7.2
           IF FAT-SCFIN = ZERO GO TO NO-SCFIN-PAG.
           MOVE ZERO TO IND.
       NO-SCFIN-PAG-0.
           ADD 1 TO IND.
           IF IND > 6 GO TO NO-SCFIN-PAG.
           IF IMPON (IND) = ZERO GO TO NO-SCFIN-PAG-0.
           COMPUTE RD-NUM = ( IMPON (IND) * SCONTO ) / 100.
           CALL 'vrround' USING NNN-X PARRD DEC-2.

           ADD 1 TO CONT.

      * Inizio DettaglioLinee x Sconto Pagamento
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DettaglioLinee' TO PWXM-TAG.
           MOVE SPACE TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'NumeroLinea' TO PWXM-TAG.
           MOVE CONT TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'TipoCessionePrestazione' TO PWXM-TAG.
           MOVE 'SC' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE '.' TO SCONXX(4:1).
           MOVE SCONTO(1:3) TO SCONXX(1:3).
           MOVE SCONTO(4:2) TO SCONXX(5:2).
           IF SCONXX(1:1) = '0' MOVE SPACE TO SCONXX(1:1)
              IF SCONXX(2:1) = '0' MOVE SPACE TO SCONXX(2:1).
           STRING 'SCONTO ' SCONXX ' %' DELIMITED SIZE INTO PWXM-CAMPO.
           MOVE 'Descrizione' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'PrezzoUnitario' TO PWXM-TAG.
           MOVE RD-NUM TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           IF RD-NUM > ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO
              ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'PrezzoTotale' TO PWXM-TAG.
           MOVE RD-NUM TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           IF RD-NUM > ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO
              ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'AliquotaIVA' TO PWXM-TAG.
           MOVE CDIVA (IND) TO KTB-COD COMCDIVA.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE ZERO TO T03-ALIVA.
           MOVE T03-ALIVA TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           PERFORM NATURA THRU EX-NATURA.
      *
      *
      * Fine DettaglioLinee
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
            
           GO TO NO-SCFIN-PAG-0.
       NO-SCFIN-PAG.
      ************
           PERFORM SOMMA-IMBALLI THRU EX-SOMMA-IMBALLI.
           PERFORM G00-STAMPA-IMBALLI THRU G99.
           IF ESTPIVA NOT = 3 PERFORM STAMPA-CONAI THRU EX-STAMPA-CONAI.
           PERFORM F00-STAMPA-MESSAGG-FATT THRU F99.
           PERFORM STAMPA-NOTEIVA THRU EX-STAMPA-NOTEIVA.
      **** rel 7.2
           MOVE KFT-AZI     TO PFPER-AZI.
           MOVE FAT-CATT    TO PFPER-CATT.
           MOVE KEYFT       TO PFPER-KEYFT.
           MOVE KEYCR       TO PFPER-KEYCR.
           MOVE 6           TO PFPER-TIPO.
           MOVE PWXM-NOMEFX TO PFPER-NFILE.
           MOVE CONT        TO PFPER-CONT.
           MOVE 1           TO PFPER-SCRIVI.
           MOVE SAVALIVA    TO PFPER-SAVALIVA.
           MOVE SAVNATURA   TO PFPER-SAVNATURA.
           CALL 'vrcfper' USING PARFPER PARWXML.
           MOVE PFPER-CONT TO CONT.
      ************
           PERFORM CASTELLETTO-IVA THRU EX-CASTELLETTO-IVA.
      * Fine DatiBeniServizi
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
           MOVE FAT-CDPAG TO KTB-COD.
      *
           MOVE FAT-CDPAG TO KTB-COD.
           MOVE 4 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE ZERO TO T04-NRATE.
           MOVE KEYTB TO KEYB2P.
           READ B2BTPA INVALID MOVE ZERO TO B2P-MPAG.
           IF B2P-MPAG = '00'
              MOVE 'Attenzione non  stata selezionata la ' TO F-MES1
              STRING 'modalit di pagamento sul codice ' FAT-CDPAG 
                     DELIMITED SIZE INTO F-MES2
              MOVE 'La fattura verr esportata senza dati ' TO F-MES3
              MOVE 'di pagamento.(non obbligatori)        ' TO F-MES4
              MOVE 4 TO F-NMES
              CALL 'vrmbox' USING PARMB
      **** rel 7.2
      *       GO TO NOPAGAM.
              GO TO NODETPAG.
      ************
      **** rel 7.2
           MOVE ZERO TO FLGNOPAG.
           MOVE 1 TO K.
           PERFORM UNTIL K = 13 OR FLGNOPAG = 1
               IF FAT-DTSCA(K) NOT = ZERO
                  MOVE 1 TO FLGNOPAG
               END-IF
               ADD 1 TO K.
           IF FLGNOPAG = ZERO
              GO TO NODETPAG.
      ************
      * Inizio DatiPagamento
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiPagamento' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'CondizioniPagamento' TO PWXM-TAG.
           IF T04-NRATE > 1
              MOVE 'TP01' TO PWXM-CAMPO.
           IF T04-NRATE = 1
              MOVE 'TP02' TO PWXM-CAMPO.
           IF AFT-TIPO = 2
              MOVE 'TP03' TO PWXM-CAMPO.
      * caso pagamento misto
           IF T04-NRATE = ZERO
              MOVE 'TP01' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 1 TO K.
           PERFORM UNTIL FAT-DTSCA(K) = ZERO
               PERFORM CASTELLETTO-RATA THRU EX-CASTELLETTO-RATA
               ADD 1 TO K.
      * Fine DatiPagamento
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      **** rel 7.2
       NODETPAG.
      * Allegati
           MOVE KBC-NUM  TO AF-NUM.
           MOVE KFT-NUM  TO AF-BOL.
           MOVE FAT-CATT TO AF-CATT.
      *
           MOVE 1          TO AG-FUN.
           MOVE KFT-AZI    TO AG-AZI.
           MOVE 'FAT'      TO AG-TIP.
           MOVE ALG-KEY    TO AG-KEY.
           CALL 'rkalg' USING PARAG.
           IF AG-ST > ZERO GO TO ERRIO.
      *
           MOVE KFT-AZI    TO KALG-AZI.
           MOVE 'FAT'      TO KALG-TIP.
           MOVE AG-KFD     TO KALG-KFD.
           MOVE SPACE      TO KALG-COD.
           START ALLEGA KEY NOT < KEYALG INVALID GO TO ENDALG.
       NEWALG.
           READ ALLEGA NEXT AT END GO TO ENDALG.
           IF SF-ALG = '9D' OR '9A' OR '35' GO TO NEWALG.
           IF KALG-AZI > KFT-AZI GO TO ENDALG.
           IF KALG-TIP > 'FAT'    GO TO ENDALG.
           IF KALG-KFD > AG-KFD   GO TO ENDALG.
           IF ALG-FATTPA = ZERO GO TO NEWALG.
      * Inizio Allegati
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Allegati' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'NomeAttachment' TO PWXM-TAG.
           MOVE ZERO      TO PWXM-TIPO.
           PERFORM NMFILE THRU EX-NMFILE.
           STRING NOMEFILE(1:LUNGNOME) '.' ALG-TFILE DELIMITED
                  SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'FormatoAttachment' TO PWXM-TAG.
           MOVE ZERO      TO PWXM-TIPO.
           MOVE ALG-TFILE TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'DescrizioneAttachment' TO PWXM-TAG.
           MOVE ZERO      TO PWXM-TIPO.
           MOVE ALG-DESCR TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Attachment' TO PWXM-TAG.
           MOVE 6         TO PWXM-TIPO.
           MOVE ALG-NFILE TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
      * Fine Allegati
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           GO TO NEWALG.
       ENDALG.
      ************
       NOPAGAM.
      * Fine Body
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      * Fine XML
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       EX-FINE-BODY.
           EXIT.
      *------------------
       T-CIFRA.
           MOVE 1 TO K1.
           PERFORM UNTIL COMNUM(K1:1) NOT = ZERO
             ADD 1 TO K1. 
           IF K1 > 10
              MOVE 10 TO K1. 
       EX-T-CIFRA.
           EXIT.
      *------------------
       CASTELLETTO-IVA.
           MOVE ZERO TO K.
       LOOPIVA.
           ADD 1 TO K.
           IF K > 6 GO TO EX-CASTELLETTO-IVA.
           IF FAT-CDIVA(K) = ZERO GO TO EX-CASTELLETTO-IVA.
           MOVE FAT-CDIVA(K) TO KTB-COD COMCDIVA.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
                       GO TO LOOPIVA.
      **** rel 7.2
           IF FAT-SPBOL = ZERO GO TO LOOPIVA-NO-BOLLO.
           IF FAT-CDIVA(K) NOT = IVABL GO TO LOOPIVA-NO-BOLLO.
                   
      *    IF COMVALUT = 'EUR'
      *       COMPUTE FAT-IMPON(K) = FAT-IMPON(K) - FAT-SPBOL
      *    ELSE
      *       COMPUTE FAT-EIMPON(K) = FAT-EIMPON(K) - FAT-ESPBOL.
           
           IF COMVALUT = 'EUR' AND FAT-IMPON(K) = ZERO
              GO TO LOOPIVA.
           IF COMVALUT NOT = 'EUR' AND FAT-EIMPON(K) = ZERO
              GO TO LOOPIVA.
 
       LOOPIVA-NO-BOLLO.
      *************
      * Inizio DatiRiepilogo
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiRiepilogo' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'AliquotaIVA' TO PWXM-TAG.
           MOVE T03-ALIVA TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           PERFORM NATURA THRU EX-NATURA.
      *
      **** rel 7.2
           MOVE 1 TO K2.
           PERFORM UNTIL K2 > 6
               IF CDIVA2(K2) = FAT-CDIVA(K) 
                  IF SPES(K2) NOT = ZERO 
                     MOVE 'SpeseAccessorie' TO PWXM-TAG
                     MOVE  SPES(K2) TO COMNUM
                     PERFORM T-CIFRA THRU EX-T-CIFRA
                     IF SPES(K2) < ZERO
                     STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                          DELIMITED SIZE INTO PWXM-CAMPO
                     ELSE
                     STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                          DELIMITED SIZE INTO PWXM-CAMPO
                     END-IF
                     call 'vxml-wr-2-72' using parwxml
                  END-IF
               END-IF
               ADD 1 TO K2.
      ************
           MOVE 'ImponibileImporto' TO PWXM-TAG.
           IF COMVALUT = 'EUR'
              MOVE FAT-IMPON(K) TO COMNUM
           ELSE
              MOVE FAT-EIMPON(K) TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
      **** rel 7.2
      *    STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
      *           DELIMITED SIZE INTO PWXM-CAMPO.
           IF FAT-IMPON(K) < ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO
           ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO.
      ************
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Imposta' TO PWXM-TAG.
           IF COMVALUT = 'EUR'
              MOVE FAT-IMPOS(K) TO COMNUM
           ELSE
              MOVE FAT-EIMPOS(K) TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
      **** rel 7.2
      *    STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
      *           DELIMITED SIZE INTO PWXM-CAMPO.
           IF FAT-IMPOS(K) < ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO
           ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO.
      ************
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'EsigibilitaIVA' TO PWXM-TAG.
           IF KFT-TDOC = 4 OR 6 
              IF FAT-DATA >= 42005 AND AFT-MCIVA = ZERO 
                 MOVE 'S' TO PWXM-CAMPO
              ELSE
                 MOVE 'D' TO PWXM-CAMPO
              END-IF
           ELSE
              MOVE 'I' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF T03-ALIVA = ZERO
              MOVE 'RiferimentoNormativo' TO PWXM-TAG
              MOVE TAB-DESCR TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      * Fine DatiRiepilogo
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           GO TO LOOPIVA.
       EX-CASTELLETTO-IVA.
           EXIT.
      *------------------
       CASTELLETTO-RATA.
      * Inizio DettaglioPagamento
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DettaglioPagamento' TO PWXM-TAG.
           MOVE SPACE TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF T04-NRATE = ZERO
              IF FAT-TPAG(K) NOT = ZERO AND
                 FAT-TPAG(K) NOT = SPACE AND
                 FAT-TPAG(K) NOT = LOW-VALUE AND
                 FAT-TPAG(K) NOT = HIGH-VALUE
                 MOVE 'ModalitaPagamento' TO PWXM-TAG
                 STRING 'MP' TFE-TP(FAT-TPAG(K)) DELIMITED 
                        SIZE INTO PWXM-CAMPO
                 call 'vxml-wr-2-72' using parwxml
              ELSE
                 MOVE 'ModalitaPagamento' TO PWXM-TAG
                 STRING 'MP' B2P-MPAG DELIMITED SIZE INTO PWXM-CAMPO
                 call 'vxml-wr-2-72' using parwxml
              END-IF
           ELSE
              MOVE 'ModalitaPagamento' TO PWXM-TAG
              STRING 'MP' B2P-MPAG DELIMITED SIZE INTO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
           
      *
           MOVE 'DataScadenzaPagamento' TO PWXM-TAG.
           MOVE 2 TO TIPOP1.
           MOVE FAT-DTSCA(K) TO AAGGG.
           CALL 'rdata' USING PARCDT.
           STRING AA4 '-' MM4 '-' GG4 DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'ImportoPagamento' TO PWXM-TAG.
           IF COMVALUT = 'EUR'
              MOVE FAT-IMPOR(K) TO COMNUM
           ELSE
              MOVE FAT-EIMPOR(K) TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
      **** rel 7.1
           MOVE ZERO TO PARIBAN.
           MOVE SPACE TO D-IBAN D-ABI D-CAB.
           MOVE ABA-CIBAN TO IBAN.
           CALL 'riban' USING PARIBAN PARBBAN.
           IF T04-NRATE = ZERO
              IF FAT-TPAG(K) NOT = 2
                 GO TO TIPAG05
              END-IF
              IF TFE-TP(FAT-TPAG(K)) NOT = 12
                 GO TO TIPAGFI
              END-IF
           ELSE
              IF T04-TIPAG NOT = 2
                 GO TO TIPAG05
              END-IF
              IF B2P-MPAG NOT = 12
                 GO TO TIPAGFI.
           IF BAN-CODAZ NOT = '00000' MOVE BAN-CODAZ TO D-ABI.
           IF BAN-CODSP NOT = '00000000' MOVE BAN-CODSP TO D-CAB.
      *
           IF IBAN-FLG NOT = 9
              MOVE BBAN-ABI TO D-ABI
              MOVE BBAN-CAB TO D-CAB.
           MOVE 'ABI' TO PWXM-TAG.
           MOVE D-ABI TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'CAB' TO PWXM-TAG.
           MOVE D-CAB TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
           GO TO TIPAGFI.
      *
       TIPAG05. 
           IF T04-NRATE = ZERO
              IF FAT-TPAG(K) NOT = ZERO AND
                 FAT-TPAG(K) NOT = SPACE AND
                 FAT-TPAG(K) NOT = LOW-VALUE AND
                 FAT-TPAG(K) NOT = HIGH-VALUE
                 IF TFE-TP(FAT-TPAG(K)) NOT = 05 
                    GO TO TIPAGFI
                 ELSE
      **** rel 7.2
      *             IF B2P-MPAG NOT = 05
                    IF T04-TIPAG NOT = 5
      ************
                       GO TO TIPAGFI
                    END-IF
                 END-IF
              END-IF
           ELSE
      **** rel 7.2
      *       IF B2P-MPAG NOT = 05
              IF T04-TIPAG NOT = 5
      ************
                 GO TO TIPAGFI.
           IF IBAN-FLG = 9  GO TO TIPAGFI.
           STRING ABA-PAE ABA-CTR ABA-COD 
                  DELIMITED SIZE INTO D-IBAN.
           MOVE 'IBAN' TO PWXM-TAG.
           MOVE D-IBAN TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
       TIPAGFI.
           IF BAN-SWIFT NOT = SPACE
              MOVE 'BIC' TO PWXM-TAG
              MOVE BAN-SWIFT TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      ************
      * Fine DettaglioPagamento
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       EX-CASTELLETTO-RATA.
           EXIT.
      *------------------
       CERCA-ORD.
           MOVE ZERO  TO K FLGORD SAVORD SAVALIVA SAV-KEYULT CONT2.
           MOVE ZERO  TO K FLGBCT SAVNUM SAVBCT.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
           MOVE SPACE TO SAVNATURA.
      **** rel 7.2
           MOVE KFT-AZI     TO PFPER-AZI.
           MOVE FAT-CATT    TO PFPER-CATT.
           MOVE KEYFT       TO PFPER-KEYFT.
           MOVE ZERO        TO PFPER-KEYCR.
           MOVE 1           TO PFPER-TIPO.
           MOVE SPACE       TO PFPER-NFILE.
           MOVE CONT2       TO PFPER-CONT.
           MOVE ZERO        TO PFPER-SCRIVI.
           MOVE ZERO        TO PFPER-SAVALIVA.
           MOVE SPACE       TO PFPER-SAVNATURA.
           CALL 'vrcfper' USING PARFPER PARWXML.
           MOVE PFPER-CONT TO CONT2.
      ************
       NEXTBCT.
           ADD 1 TO K.
           IF RB-TNUM(K) = ZERO OR
              RB-NBOL(K) = ZERO
              GO TO EX-CERCA-ORD.
      *
           IF SAVNUM NOT = RB-TNUM(K) OR
              SAVBCT NOT = RB-NBOL(K)
              IF SAVNUM = ZERO AND
                 SAVBCT = ZERO
                 MOVE RB-TNUM(K) TO SAVNUM
                 MOVE RB-NBOL(K) TO SAVBCT
              ELSE
                 MOVE 1 TO FLGBCT.
      *
      **** rel 7.2
           MOVE KFT-AZI     TO PFPER-AZI.
           MOVE FAT-CATT    TO PFPER-CATT.
           MOVE KEYFT       TO PFPER-KEYFT.
           MOVE ZERO        TO PFPER-KEYCR.
           MOVE KFT-AZI     TO PFPER-KCR-AZI.
           MOVE RB-TNUM(K)  TO PFPER-KCR-NUM.
           MOVE RB-NBOL(K)  TO PFPER-KCR-BOL.
           MOVE 2           TO PFPER-TIPO.
           MOVE SPACE       TO PFPER-NFILE.
           MOVE CONT2       TO PFPER-CONT.
           MOVE ZERO        TO PFPER-SCRIVI.
           MOVE ZERO        TO PFPER-SAVALIVA.
           MOVE SPACE       TO PFPER-SAVNATURA.
           CALL 'vrcfper' USING PARFPER PARWXML.
           MOVE PFPER-CONT TO CONT2.
      ************
           MOVE KFT-AZI    TO KCR-AZI.
           MOVE RB-TNUM(K) TO KCR-NUM.
           MOVE RB-NBOL(K) TO KCR-BOL.
           MOVE ZERO       TO KCR-PGR. 
           START BOLCRI KEY NOT < KEYCR INVALID GO TO ENDBCR2.
       NEWBCR2.
           READ BOLCRI NEXT AT END GO TO ENDBCR2.
           IF SF-BCR = '9D' OR '9A' OR '35' GO TO NEWBCR2.
           IF KCR-AZI > KFT-AZI    GO TO ENDBCR2.
           IF KCR-NUM > RB-TNUM(K) GO TO ENDBCR2.
           IF KCR-BOL > RB-NBOL(K) GO TO ENDBCR2.
           IF BCR-DESCR = SPACE
              GO TO NEWBCR2.
           IF BCR-TCOR = 1 AND BCR-FSC  = 2 GO TO NEWBCR2.
      *
      **** rel 7.2
           MOVE KFT-AZI     TO PFPER-AZI.
           MOVE FAT-CATT    TO PFPER-CATT.
           MOVE KEYFT       TO PFPER-KEYFT.
           MOVE KEYCR       TO PFPER-KEYCR.
           MOVE 3           TO PFPER-TIPO.
           MOVE SPACE       TO PFPER-NFILE.
           MOVE CONT2       TO PFPER-CONT.
           MOVE ZERO        TO PFPER-SCRIVI.
           MOVE ZERO        TO PFPER-SAVALIVA.
           MOVE SPACE       TO PFPER-SAVNATURA.
           CALL 'vrcfper' USING PARFPER PARWXML.
           MOVE PFPER-CONT TO CONT2.
      ************
           ADD 1 TO CONT2.
           IF BCR-NORD NOT = ZERO
              MOVE KCR-AZI  TO KLV-AZI
              MOVE BCR-NORD TO KLV-NUM
              MOVE KCR-NUM  TO KLV-NBOL
              MOVE KCR-BOL  TO KLV-NUBOL
              MOVE CONT2    TO KLV-PRGN
              WRITE RF-LAV NOT INVALID
                    IF FLGORD NOT = 2
                       MOVE 1 TO FLGORD
                       IF SAVORD NOT = BCR-NORD
                          IF SAVORD NOT = ZERO
                             MOVE 2 TO FLGORD  
                          ELSE
                             MOVE BCR-NORD TO SAVORD.
      *
           MOVE KEYCR TO SAV-KEYULT.
           IF BCR-TCOR = 4 OR 5
              MOVE BCR-RIVGR TO BCR-IVA .
           IF FAT-CDESE NOT = ZERO
              MOVE FAT-CDESE TO BCR-IVA.
           IF BCR-IVA NOT = ZERO AND
              SAVALIVA = ZERO AND
              SAVNATURA = SPACE
              MOVE BCR-IVA TO KTB-COD
              MOVE 3 TO KTB-TIP
              READ TABELL INTO REKTAB NOT INVALID
                 MOVE T03-ALIVA TO SAVALIVA
                 MOVE 03      TO KSPI-TIP
                 MOVE BCR-IVA TO KSPI-COD
                 READ SPEIVA NOT INVALID
                      MOVE SPI-NATURA TO SAVNATURA
                      GO TO SKIPPA
                 END-READ
                 IF T03-TPIVA = ZERO
                    IF T03-TSAUE = 1
                       MOVE 'N5' TO SAVNATURA
                    ELSE 
                       IF T03-ALIVA = ZERO
                          MOVE 'N6' TO SAVNATURA
                       END-IF
                    END-IF
                 END-IF
                 IF T03-TPIVA = 2
                    MOVE 'N4' TO SAVNATURA
                 END-IF
                 IF T03-TPIVA = 3
                    MOVE 'N3' TO SAVNATURA
                 END-IF
                 IF T03-TPIVA = 4
                    MOVE 'N2' TO SAVNATURA
                 END-IF
                 IF T03-TPIVA = 5
                    MOVE 'N1' TO SAVNATURA
                 END-IF
                 IF T03-TPIVA = 6
                    MOVE 'N3' TO SAVNATURA.
       SKIPPA.
      *
           MOVE KCR-AZI  TO KLV-AZI.
           MOVE BCR-NORD TO KLV-NUM.
           MOVE KCR-NUM  TO KLV-NBOL.
           MOVE KCR-BOL  TO KLV-NUBOL.
           MOVE CONT2    TO KLV-PRGN.
           WRITE RF-LAV.
      *
      **** rel 7.2
           MOVE KFT-AZI     TO PFPER-AZI.
           MOVE FAT-CATT    TO PFPER-CATT.
           MOVE KEYFT       TO PFPER-KEYFT.
           MOVE KEYCR       TO PFPER-KEYCR.
           MOVE 4           TO PFPER-TIPO.
           MOVE SPACE       TO PFPER-NFILE.
           MOVE CONT2       TO PFPER-CONT.
           MOVE ZERO        TO PFPER-SCRIVI.
           MOVE ZERO        TO PFPER-SAVALIVA.
           MOVE SPACE       TO PFPER-SAVNATURA.
           CALL 'vrcfper' USING PARFPER PARWXML.
           MOVE PFPER-CONT TO CONT2.
      ************
           GO TO NEWBCR2.
       ENDBCR2.
      *
      **** rel 7.2
           MOVE KFT-AZI     TO PFPER-AZI.
           MOVE FAT-CATT    TO PFPER-CATT.
           MOVE KEYFT       TO PFPER-KEYFT.
           MOVE ZERO        TO PFPER-KEYCR.
           MOVE KFT-AZI     TO PFPER-KCR-AZI.
           MOVE RB-TNUM(K)  TO PFPER-KCR-NUM.
           MOVE RB-NBOL(K)  TO PFPER-KCR-BOL.
           MOVE 5           TO PFPER-TIPO.
           MOVE SPACE       TO PFPER-NFILE.
           MOVE CONT2       TO PFPER-CONT.
           MOVE ZERO        TO PFPER-SCRIVI.
           MOVE ZERO        TO PFPER-SAVALIVA.
           MOVE SPACE       TO PFPER-SAVNATURA.
           CALL 'vrcfper' USING PARFPER PARWXML.
           MOVE PFPER-CONT TO CONT2.
      ************
           GO TO NEXTBCT.
       EX-CERCA-ORD.
           EXIT.
      *------------------
       NATURA.
           MOVE 03      TO KSPI-TIP.
      **** rel 7.2
      *    MOVE BCR-IVA TO KSPI-COD.
           MOVE COMCDIVA TO KSPI-COD.
      ************
           READ SPEIVA NOT INVALID
                MOVE SPI-NATURA TO PWXM-CAMPO
      **** rel 7.2
      *         GO TO EX-NATURA.
                GO TO ESPORTA-NATURA.
      ************
      *    
           IF T03-TPIVA = ZERO
      **** rel 7.2
      *       IF T03-TSAUE = 1
      *          MOVE 'N5' TO PWXM-CAMPO
      *       ELSE 
      *          GO TO EX-NATURA.
              IF T03-TSAUE = 1
                 MOVE 'N5' TO PWXM-CAMPO
              ELSE 
                 IF T03-ALIVA = ZERO
                    MOVE 'N6' TO PWXM-CAMPO
                 ELSE
                    GO TO EX-NATURA.
      ************
           IF T03-TPIVA = 1
              GO TO EX-NATURA.
           IF T03-TPIVA = 2
              MOVE 'N4' TO PWXM-CAMPO.
           IF T03-TPIVA = 3
              MOVE 'N3' TO PWXM-CAMPO.
           IF T03-TPIVA = 4
              MOVE 'N2' TO PWXM-CAMPO.
           IF T03-TPIVA = 5
              MOVE 'N1' TO PWXM-CAMPO.
           IF T03-TPIVA = 6
              MOVE 'N3' TO PWXM-CAMPO.
           IF T03-TPIVA = 7
              GO TO EX-NATURA.
      **** rel 7.2
       ESPORTA-NATURA.
      ************
           MOVE 'Natura' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
       EX-NATURA.
           EXIT.
      *------------------
      **** rel 7.2
       NMFILE.
          MOVE 150 TO K3 ENDFILE.
          MOVE ZERO TO LUNGNOME.
          PERFORM UNTIL K3 = ZERO
             IF ALG-NFILE(K3:1) = '.' AND ENDFILE = 150
                MOVE K3 TO ENDFILE
             END-IF 
             IF ALG-NFILE(K3:1)  = '\' OR '/'
                ADD 1 TO K3
                COMPUTE LUNGNOME = ENDFILE - K3
                MOVE ALG-NFILE(K3:LUNGNOME) TO NOMEFILE
                GO TO EX-NMFILE
             END-IF
             SUBTRACT 1 FROM K3.
       EX-NMFILE.
           EXIT.
      *------------------
       RCDIVA.
           IF BCR-TCOR NOT = ZERO AND
              BCR-TCOR NOT = 2
              GO TO EX-RCDIVA.
           MOVE ZERO TO IND.
       RCDIVA-1.
           ADD 1 TO IND.
           IF IND > 6 GO TO RCDIVA-6.
           IF CDIVA (IND) = ZERO
              MOVE SAVPRZ TO IMPON (IND)
              MOVE KTB-COD TO CDIVA (IND)
              GO TO EX-RCDIVA.
           IF KTB-COD = CDIVA (IND)
              ADD SAVPRZ TO IMPON (IND)
              GO TO EX-RCDIVA.
           GO TO RCDIVA-1.
       RCDIVA-6.
           MOVE 6 TO IND.
           ADD SAVPRZ TO IMPON (IND).
       EX-RCDIVA.
           EXIT.
      ************
      **** rel 7.2
       SPESEAC.
           MOVE ZERO TO IND.
       SPESEAC-1.
           ADD 1 TO IND.
           IF IND > 6 GO TO SPESEAC-6.
           IF CDIVA2(IND) = ZERO
              MOVE SAVPRZ2 TO SPES(IND)
              MOVE KTB-COD TO CDIVA2(IND)
              GO TO EX-SPESEAC.
           IF KTB-COD = CDIVA2(IND)
              ADD SAVPRZ2 TO SPES(IND)
              GO TO EX-SPESEAC.
           GO TO SPESEAC-1.
       SPESEAC-6.
           MOVE 6 TO IND.
           ADD SAVPRZ2 TO SPES(IND).
       EX-SPESEAC.
           EXIT.
      *------------------
       INCR-PROG.
           MOVE 5 TO POSIZ.
       LOOPNUM.
           IF PROGN(POSIZ) = '0' MOVE '1' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = '1' MOVE '2' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = '2' MOVE '3' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = '3' MOVE '4' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = '4' MOVE '5' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = '5' MOVE '6' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = '6' MOVE '7' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = '7' MOVE '8' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = '8' MOVE '9' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = '9' MOVE 'A' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'A' MOVE 'B' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'B' MOVE 'C' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'C' MOVE 'D' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'D' MOVE 'E' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'E' MOVE 'F' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'F' MOVE 'G' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'G' MOVE 'H' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'H' MOVE 'I' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'I' MOVE 'J' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'J' MOVE 'K' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'K' MOVE 'L' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'L' MOVE 'M' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'M' MOVE 'N' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'N' MOVE 'O' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'O' MOVE 'P' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'P' MOVE 'Q' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'Q' MOVE 'R' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'R' MOVE 'S' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'S' MOVE 'T' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'T' MOVE 'V' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'V' MOVE 'W' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'W' MOVE 'X' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'X' MOVE 'Y' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'Y' MOVE 'Z' TO PROGN(POSIZ)
           ELSE
           IF PROGN(POSIZ) = 'Z' MOVE '0' TO PROGN(POSIZ)
                                 SUBTRACT 1 FROM POSIZ
                                 GO TO LOOPNUM.
       EX-INCR-PROG.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
      *
           MOVE SPACE TO ID-WSI.
           STRING 'w0' PID DELIMITED SPACE INTO ID-WSI.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       LISTA-ORDINI.
           MOVE SPACE TO COM-VSORD.
           MOVE ZERO  TO COM-NUM.
           MOVE ZERO  TO COM-DTORD.
      *
           MOVE KFT-AZI    TO KLV-AZI.
           MOVE ZERO       TO KLV-NUM SAVORD.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO ENDLAV.
       NEWLAV.
           READ WDSLAV NEXT AT END GO TO ENDLAV.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO NEWLAV.
           IF KLV-AZI > KFT-AZI    GO TO ENDLAV.
           IF KLV-NUM = ZERO GO TO NEWLAV.
           IF FLGORD NOT = 2
              IF SAVORD NOT = ZERO
                 IF KLV-NUM = SAVORD
                    GO TO NEWLAV.
      *
           MOVE KLV-AZI TO KOR-AZI.
           MOVE KLV-NUM TO KOR-NUM.
           READ ORDCLI INTO REKORD INVALID KEY
                GO TO NEWLAV.
      *
           IF KLV-NUM NOT = SAVORD
              IF SAVORD NOT = ZERO
                 PERFORM DATI-ORDINE THRU EX-DATI-ORDINE
      *
      * Fine DatiOrdineAcquisto
                 MOVE '-'  TO PWXM-FUN
                 call 'vxml-wr-2-72' using parwxml
              END-IF
      * Inizio DatiOrdineAcquisto
              MOVE '+'  TO PWXM-FUN
              MOVE 'DatiOrdineAcquisto' TO PWXM-TAG
              call 'vxml-wr-2-72' using parwxml.
      *
           MOVE KLV-NUM TO SAVORD.
      *
           IF FLGORD = 2
              MOVE 'RiferimentoNumeroLinea' TO PWXM-TAG
              MOVE KLV-PRGN TO COM-PRG
              MOVE COM-PRG TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
           MOVE ORD-VSORD TO COM-VSORD.
           MOVE KOR-NUM   TO COM-NUM.
           MOVE ORD-DAT   TO COM-DTORD.
      *
           GO TO NEWLAV.
       ENDLAV.
           IF COM-NUM = ZERO
              GO TO EX-LISTA-ORDINI.
      *
           PERFORM DATI-ORDINE THRU EX-DATI-ORDINE.
      *
      * Fie DatiOrdineAcquisto
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       EX-LISTA-ORDINI.
           EXIT.
      *------------------
       LETTERA-DINT.
           IF BCR-TCOR = 1
              GO TO EX-LETTERA-DINT.
           IF FAT-CDESE = ZERO GO TO NO-INTENTO.
           MOVE FAT-CDESE TO KTB-COD.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB  INVALID
                MOVE ZERO TO T03-TPIVA.
           IF CLF-ENUIVA = ZERO GO TO NO-INTENTO.
           IF T03-TPIVA NOT = 6 GO TO NO-INTENTO.
      *
      * Inizio AltriDatiGestionali
           MOVE '+'  TO PWXM-FUN.
           MOVE 'AltriDatiGestionali' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'TipoDato' TO PWXM-TAG.
           MOVE ZERO       TO PWXM-TIPO.
           MOVE 'AswDichInt' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'RiferimentoTesto' TO PWXM-TAG.
           MOVE ZERO      TO PWXM-TIPO.
           MOVE CLF-INUIVA TO INUIVA.
           MOVE 2    TO TIPOP1.
           MOVE CLF-IDTIVA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           STRING INUIVA '/' AA4 DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'RiferimentoNumero' TO PWXM-TAG.
           MOVE ZERO       TO PWXM-TIPO.
           MOVE CLF-ENUIVA TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'RiferimentoData' TO PWXM-TAG.
           MOVE ZERO TO PWXM-TIPO.
           MOVE 2    TO TIPOP1.
           MOVE CLF-EDTIVA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           STRING AA4 '-' MM4 '-' GG4 DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
      * Fine AltriDatiGestionali
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
       NO-INTENTO.
      *
       EX-LETTERA-DINT.
           EXIT.
      *------------------
       DATI-ORDINE.
           MOVE 'IdDocumento' TO PWXM-TAG.
           STRING COM-VSORD ' NS: ' COM-NUM
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Data' TO PWXM-TAG.
           MOVE 2 TO TIPOP1.
           MOVE COM-DTORD TO AAGGG.
           CALL 'rdata' USING PARCDT.
           STRING AA4 '-' MM4 '-' GG4 DELIMITED SIZE 
                  INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF AFT-CUP NOT = SPACE
              MOVE 'CodiceCUP' TO PWXM-TAG
              MOVE AFT-CUP TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
           IF AFT-CIG NOT = SPACE
              MOVE 'CodiceCIG' TO PWXM-TAG
              MOVE AFT-CIG TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
       EX-DATI-ORDINE.
           EXIT.
      *------------------
       DETTAGLI-OMA.
           IF BCR-TCOR = 6 GO TO EX-DETTAGLI-OMA.
      *
      * Inizio AltriDatiGestionali
           MOVE '+'  TO PWXM-FUN.
           MOVE 'AltriDatiGestionali' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'TipoDato' TO PWXM-TAG.
           MOVE ZERO       TO PWXM-TIPO.
           MOVE 'AswTRiga' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'RiferimentoTesto' TO PWXM-TAG.
           IF BCR-TCOR = 5
              MOVE 'Sconto merce #SM#' TO PWXM-CAMPO
           ELSE
              IF BCR-RIVAL = 1
                 MOVE 'Omaggio senza rivalsa #OS#' TO PWXM-CAMPO
              ELSE 
                 MOVE 'Omaggio con rivalsa #OC#' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
      * Fine AltriDatiGestionali
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
       EX-DETTAGLI-OMA.
           EXIT.
      *------------------
       VERIFICA-CARTELLA.
           MOVE SPACE TO CARTELLA.
           MOVE 2 TO TIPOP1.
           MOVE FAT-DATA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           STRING TFE-PERC DELIMITED SPACE
                  AA4      DELIMITED SPACE
                  '-'      DELIMITED SPACE
                  MM4      DELIMITED SPACE
                  '-'      DELIMITED SPACE
                  GG4      DELIMITED SPACE
                  '\' DELIMITED SIZE INTO CARTELLA.
      *
           MOVE CARTELLA TO F-FILEIN.
           PERFORM EXIST-DIR.
           IF F-ERROR = ZERO
              GO TO EX-VERIFICA-CARTELLA.
      * crea dir output (se esiste gia' ignora)
           MOVE CARTELLA TO PATH-NAME.
           CALL "CBL_CREATE_DIR" USING  PATH-NAME
                              RETURNING STATUS-CODE.
      *
       EX-VERIFICA-CARTELLA.
           EXIT.
      *------------------
       EXIST-DIR.
      * input : F-FILEIN = dir da controllare
      * output: F-ERROR  = 0 se dir esiste
           MOVE 3      TO F-ACTION.
           MOVE 16     TO F-ATTRIN.
           MOVE ZERO   TO F-HANDLE.
           MOVE SPACE  TO F-FILEOUT.
           CALL X"91" USING RESULT
                            FUNCTION-CODE
                            PARAMETER.
      *------------------
      ************
       STAMPA-NOTEIVA.
           MOVE SPACE TO COMNOTE COM-DESC.
           MOVE ZERO TO FLGTES.
      *
           IF FAT-CDESE = ZERO GO TO I20.
      *
           MOVE 3       TO KNTA-TIP.
           MOVE FAT-CDESE TO KNTA-COD.
           MOVE ZERO    TO KNTA-PRG.
           START NOTTAB KEY >= KEYNTA INVALID GO TO I20.
       I10.
           MOVE COMNOTE TO COM-DESC.
           READ NOTTAB NEXT AT END GO TO I20.
           IF KNTA-TIP > 3         GO TO I20.
           IF KNTA-COD > FAT-CDESE GO TO I20.
      *
           PERFORM CERCA-ULTIMO THRU EX-CERCA-ULTIMO.
           STRING COM-DESC(1:KU2) ' '
                  NTA-DESCR DELIMITED BY SIZE 
                  INTO COMNOTE.
      *
           MOVE 1 TO FLGTES.
      *
           GO TO I10.
       I20.
      *
           IF FLGTES = 1 GO TO END-NOTEIVA.
           MOVE ZERO TO K.
      *
       LCIVA.
      *
           ADD 1 TO K.
           IF K > 6 GO TO END-NOTEIVA.
      *
           IF FAT-CDIVA (K) = ZERO GO TO END-NOTEIVA.
      *
           MOVE FAT-CDIVA (K) TO KNTA-COD.
           MOVE 3             TO KNTA-TIP.
           MOVE ZERO    TO KNTA-PRG.
           START NOTTAB KEY >= KEYNTA INVALID GO TO I98.
       I15.
           MOVE COMNOTE TO COM-DESC.
           READ NOTTAB NEXT AT END GO TO I98.
           IF KNTA-TIP > 3         GO TO I98.
           IF KNTA-COD > FAT-CDIVA (K) GO TO I98.
      *
           PERFORM CERCA-ULTIMO THRU EX-CERCA-ULTIMO.
           STRING COM-DESC(1:KU2) ' '
                  NTA-DESCR DELIMITED BY SIZE 
                  INTO COMNOTE.
      *
           MOVE 1 TO FLGTES.
      *
           GO TO I15.
      *
       I98.
      *
           GO TO LCIVA.
       END-NOTEIVA.
           IF COM-DESC = SPACE GO TO EX-STAMPA-NOTEIVA.
           ADD 1 TO CONT.
      * Inizio DettaglioLinee
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DettaglioLinee' TO PWXM-TAG.
           MOVE SPACE TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'NumeroLinea' TO PWXM-TAG.
           MOVE CONT TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE COM-DESC TO PWXM-CAMPO.
           MOVE 'Descrizione' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'PrezzoUnitario' TO PWXM-TAG.
           MOVE '0.000000' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'PrezzoTotale' TO PWXM-TAG.
           MOVE '0.000000' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'AliquotaIVA' TO PWXM-TAG.
           MOVE SAVALIVA TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF SAVNATURA NOT = SPACE
              MOVE 'Natura' TO PWXM-TAG
              MOVE SAVNATURA TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
      * Fine DettaglioLinee
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       EX-STAMPA-NOTEIVA.
           EXIT.
      *------------------
       F00-STAMPA-MESSAGG-FATT.
           MOVE SPACE TO COM-DESC COMNOTE.
      *
           MOVE ZERO TO FLGTES.
           MOVE KAZ-COD  TO P-MDT-AZI.
           MOVE 3        TO P-MDT-TDOC.
           MOVE KEYFT    TO P-MDT-KEY.
           MOVE ZERO     TO P-MDT-FLGS.
           MOVE FAT-DATA TO P-MDT-DATA.
           MOVE ZERO     TO P-MDT-FLGE.
       F10.
           CALL 'vrpmdt' USING PAR-P-MDT.
           MOVE COMNOTE TO COM-DESC.
           IF P-MDT-FLGE NOT = 1 GO TO F90.
           PERFORM CERCA-ULTIMO THRU EX-CERCA-ULTIMO.
           STRING COM-DESC(1:KU2) ' '
                  P-MDT-TESTO(1:P-MDT-NCOL) DELIMITED BY SIZE 
                  INTO COMNOTE.
      *
           MOVE 1 TO FLGTES.
           GO TO F10.
       F90.
           IF COM-DESC = SPACE GO TO NOMFAT.
           ADD 1 TO CONT.
      * Inizio DettaglioLinee
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DettaglioLinee' TO PWXM-TAG.
           MOVE SPACE TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'NumeroLinea' TO PWXM-TAG.
           MOVE CONT TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE COM-DESC TO PWXM-CAMPO.
           MOVE 'Descrizione' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'PrezzoUnitario' TO PWXM-TAG.
           MOVE '0.000000' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'PrezzoTotale' TO PWXM-TAG.
           MOVE '0.000000' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'AliquotaIVA' TO PWXM-TAG.
           MOVE SAVALIVA TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF SAVNATURA NOT = SPACE
              MOVE 'Natura' TO PWXM-TAG
              MOVE SAVNATURA TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
      * Fine DettaglioLinee
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       NOMFAT.
       F99.
           EXIT.
      *-------------------------------
       STAMPA-CONAI.
           IF CLF-CONAI NOT = 1 GO TO EX-STAMPA-CONAI.
           ADD 1 TO CONT.
      * Inizio DettaglioLinee
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DettaglioLinee' TO PWXM-TAG.
           MOVE SPACE TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'NumeroLinea' TO PWXM-TAG.
           MOVE CONT TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'CONTRIBUTO CONAI ASSOLTO OVE DOVUTO' TO PWXM-CAMPO.
           MOVE 'Descrizione' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'PrezzoUnitario' TO PWXM-TAG.
           MOVE '0.000000' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'PrezzoTotale' TO PWXM-TAG.
           MOVE '0.000000' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'AliquotaIVA' TO PWXM-TAG.
           MOVE SAVALIVA TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF SAVNATURA NOT = SPACE
              MOVE 'Natura' TO PWXM-TAG
              MOVE SAVNATURA TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
      * Fine DettaglioLinee
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       EX-STAMPA-CONAI.
           EXIT.
      *-------------------------------
       CERCA-ULTIMO.
           MOVE 500 TO KU1 KU2.
           IF COM-DESC = SPACE
              MOVE 1 TO KU1 KU2
              GO TO EX-CERCA-ULTIMO.
           PERFORM UNTIL COM-DESC(KU1:1) NOT = SPACE
               SUBTRACT 1 FROM KU1.
           MOVE KU1 TO KU2.
      *
       EX-CERCA-ULTIMO.
           EXIT.
      *-------------------------------
       SOMMA-IMBALLI.
      * azzeramento vettore totali imballi
           MOVE 1 TO INDICE.
           PERFORM UNTIL INDICE > 30
              MOVE SPACE TO VETIMB(INDICE)
              MOVE ZERO  TO VETQTA(INDICE)
              ADD 1 TO INDICE
           END-PERFORM.
      *
           MOVE ZERO  TO PREPAL PRECOL.
           MOVE SPACE TO PREIMB.
           MOVE ZERO  TO ULTIND.
      *
           MOVE LOW-VALUE TO KEYWSI.
           START WDSSIB KEY > KEYWSI INVALID GO TO EX-SOMMA-IMBALLI.
       SOMMA-IMB-10.
           READ WDSSIB NEXT AT END GO TO EX-SOMMA-IMBALLI.
           IF KWSI-NCOL = ZERO
              MOVE WSI-NIMB TO COMNIMB
              GO TO SOMMA-IMB-20.
           IF KWSI-NPAL = PREPAL AND
              KWSI-NCOL = PRECOL AND
              KWSI-IMB  = PREIMB GO TO SOMMA-IMB-10.
           MOVE 1 TO COMNIMB.
       SOMMA-IMB-20.
           MOVE KWSI-NPAL TO PREPAL.
           MOVE KWSI-NCOL TO PRECOL.
           MOVE KWSI-IMB  TO PREIMB.
      *
           MOVE 1 TO INDICE.
           PERFORM UNTIL INDICE > 30
              IF VETIMB(INDICE) = SPACE
                 MOVE KWSI-IMB TO VETIMB(INDICE)
                 MOVE COMNIMB  TO VETQTA(INDICE)
                 MOVE INDICE TO ULTIND
                 MOVE 30 TO INDICE
              ELSE
                 IF VETIMB(INDICE) = KWSI-IMB
                     ADD COMNIMB TO VETQTA(INDICE)
                     MOVE 30 TO INDICE
                 END-IF
              END-IF
              ADD 1 TO INDICE
           END-PERFORM.
      *
           GO TO SOMMA-IMB-10.
       EX-SOMMA-IMBALLI.
           EXIT.
      *-------------------------------
       G00-STAMPA-IMBALLI.
           MOVE ZERO TO INDICE.
       REPEAT.
           ADD 1 TO INDICE.
           IF INDICE > ULTIND GO TO G99.
      *
           MOVE KAZ-COD        TO KAIM-AZI.
           MOVE VETIMB(INDICE) TO KAIM-COD.
           READ ANAIMB INVALID PERFORM INVK-AIM
                               GO TO ERRIO.
      *
           ADD 1 TO CONT.
      * Inizio DettaglioLinee x Sconto Pagamento
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DettaglioLinee' TO PWXM-TAG.
           MOVE SPACE TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'NumeroLinea' TO PWXM-TAG.
           MOVE CONT TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
      * Inizio CodiceArticolo
           MOVE '+'  TO PWXM-FUN.
           MOVE 'CodiceArticolo' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'CodiceTipo' TO PWXM-TAG.
           MOVE 'CODIMB'     TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'CodiceValore' TO PWXM-TAG.
           MOVE VETIMB(INDICE) TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      * Fine CodiceArticolo
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      * 
           MOVE AIM-DESC TO PWXM-CAMPO.
           MOVE 'Descrizione' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Quantita' TO PWXM-TAG.
           MOVE VETQTA(INDICE) TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:3)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'UnitaMisura' TO PWXM-TAG.
           MOVE 'NR' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE ZERO TO COMPRZ1 COMPRZ2.
           IF FAT-VALUT = ZERO OR COMEURO
              MOVE AIM-COSU TO COMPRZ1
              COMPUTE IMPIMB = VETQTA(INDICE) * AIM-COSU
              MOVE IMPIMB TO COMPRZ2
           ELSE
              MOVE AIM-COSU TO ER-IMPORTO
              MOVE CG-CAMBIO TO ER-CAMBIO
              MOVE CG-VALUT  TO ER-VALUT
              CALL 're2imp' USING ER-IMPORTO EUR-VAL ER-VALUT ER-CAMBIO
              MOVE ER-IMPORTO TO COMPRZ1
              IF FAT-VALUT NOT = ZERO
                 MOVE ER-IMPORTO TO COMPRZ1
              END-IF
              COMPUTE ER-IMPORTO = ER-IMPORTO * VETQTA(INDICE)
              MOVE ER-IMPORTO TO COMPRZ2
              IF FAT-VALUT NOT = ZERO
                 MOVE ER-IMPORTO TO COMPRZ2.
      *
           MOVE 'PrezzoUnitario' TO PWXM-TAG.
           MOVE COMPRZ1 TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           IF COMPRZ1 < ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO
              ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'PrezzoTotale' TO PWXM-TAG.
           MOVE COMPRZ2 TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           IF COMPRZ2 < ZERO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO
              ELSE
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:6)
                     DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'AliquotaIVA' TO PWXM-TAG.
           IF FAT-CDESE = ZERO
              MOVE AIM-CDIVA TO KTB-COD COMCDIVA
           ELSE
              MOVE FAT-CDESE TO KTB-COD COMCDIVA.
           MOVE 3 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID
              MOVE ZERO TO T03-ALIVA.
           MOVE T03-ALIVA TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           PERFORM NATURA THRU EX-NATURA.
      *
      * Fine DettaglioLinee
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           GO TO REPEAT.
       G99.
           EXIT.
      *-------------------------------
       WR-LAV-IMB.
           IF NOT (BCR-TCOR = ZERO OR 2) GO TO EX-WR-LAV-IMB.
           MOVE KBC-AZI TO KPBR-AZI.
           MOVE KBC-NUM TO KPBR-TNUM.
           MOVE KBC-BOL TO KPBR-NBOL.
           MOVE KCR-PGR TO KPBR-RBOL.
           MOVE ZERO    TO KPBR-PGR.
           START PROBCR KEY NOT < KEYPBR INVALID GO TO EX-WR-LAV-IMB.
       LAV-IMB-10.
           READ PROBCR NEXT AT END GO TO EX-WR-LAV-IMB.
           IF SF-PBR = '9D' OR '9A' OR '35' GO TO LAV-IMB-10.
           IF KBC-AZI  NOT = KPBR-AZI GO TO EX-WR-LAV-IMB.
           IF KBC-NUM NOT = KPBR-TNUM GO TO EX-WR-LAV-IMB.
           IF KBC-BOL NOT = KPBR-NBOL GO TO EX-WR-LAV-IMB.
           IF KCR-PGR NOT = KPBR-RBOL GO TO EX-WR-LAV-IMB.
      *
           MOVE KBC-AZI TO KAIM-AZI.
           MOVE PBR-IMB TO KAIM-COD.
           READ ANAIMB INVALID PERFORM INVK-AIM
                               PERFORM VISK-PBR
                               GO TO ERRIO.
           IF AIM-FLGREND = 1 GO TO LAV-IMB-10.
      *
           MOVE PBR-NPAL TO KWSI-NPAL.
           MOVE PBR-NCOL TO KWSI-NCOL.
           MOVE PBR-IMB  TO KWSI-IMB.
           ADD 1         TO KWSI-PRG.
           MOVE PBR-NIMB TO WSI-NIMB.
           WRITE RF-WSI INVALID MOVE 'vfat500: WR-LAV WSI' TO MESS
                                GO TO ERRIO.
      *
           GO TO LAV-IMB-10.
       EX-WR-LAV-IMB.
           EXIT.
      *-------------------------------
       DL-LAV-IMB.
           CLOSE WDSSIB.
           OPEN OUTPUT WDSSIB.
           CLOSE WDSSIB.
           OPEN I-O WDSSIB.
           MOVE ZERO TO KWSI-PRG.
       EX-DL-LAV-IMB.
      *-------------------------------
